// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function TokenizeBooleanFormula(f, tokens, errorMessage){
  var success;
  var i;
  var ll;
  var llc;
  var str;
  var found;
  var c1, c2, c3;

  success = true;
  ll = CreateLinkedListString();
  llc = CreateLinkedListCharacter();

  for(i = 0; i < f.length && success; ){
    found = false;

    c1 = f[i];

    if(i + 2 < f.length){
      c2 = f[i + 1];
      c3 = f[i + 2];

      if(c1 == '<' && c2 == '-' && c3 == '>'){
        LinkedListAddString(ll, "<->".split(''));
        i = i + 3;
        found = true;
      }
    }

    if( !found ){
      if(i + 1 < f.length){
        c2 = f[i + 1];

        if(c1 == '<' && c2 == '='){
          LinkedListAddString(ll, "<=".split(''));
          i = i + 2;
          found = true;
        }else if(c1 == '>' && c2 == '='){
          LinkedListAddString(ll, ">=".split(''));
          i = i + 2;
          found = true;
        }else if(c1 == '!' && c2 == '='){
          LinkedListAddString(ll, "!=".split(''));
          i = i + 2;
          found = true;
        }else if(c1 == '-' && c2 == '>'){
          LinkedListAddString(ll, "->".split(''));
          i = i + 2;
          found = true;
        }
      }
    }

    if( !found ){
      if(c1 == '('){
        LinkedListAddString(ll, "(".split(''));
        i = i + 1;
        found = true;
      }else if(c1 == ')'){
        LinkedListAddString(ll, ")".split(''));
        i = i + 1;
        found = true;
      }else if(c1 == '!'){
        LinkedListAddString(ll, "!".split(''));
        i = i + 1;
        found = true;
      }else if(c1 == '&'){
        LinkedListAddString(ll, "&".split(''));
        i = i + 1;
        found = true;
      }else if(c1 == '^'){
        LinkedListAddString(ll, "^".split(''));
        i = i + 1;
        found = true;
      }else if(c1 == '|'){
        LinkedListAddString(ll, "|".split(''));
        i = i + 1;
        found = true;
      }else if(c1 == '='){
        LinkedListAddString(ll, "=".split(''));
        i = i + 1;
        found = true;
      }else if(c1 == '<'){
        LinkedListAddString(ll, "<".split(''));
        i = i + 1;
        found = true;
      }else if(c1 == '>'){
        LinkedListAddString(ll, ">".split(''));
        i = i + 1;
        found = true;
      }else if(c1 == ' ' || c1 == '\t' || c1 == '\n'){
        i = i + 1;
        found = true;
      }else if(charIsLetter(c1)){
        for(; i < f.length && (charIsLetter(f[i]) || charIsNumber(f[i]) || f[i] == '_'); i = i + 1){
          LinkedListAddCharacter(llc, f[i]);
        }
        str = LinkedListCharactersToArray(llc);
        LinkedListAddString(ll, str);
        FreeLinkedListCharacter(llc);
        llc = CreateLinkedListCharacter();

        found = true;
      }else if(charIsNumber(c1)){
        for(; i < f.length && (charIsNumber(f[i]) || f[i] == '.'); i = i + 1){
          LinkedListAddCharacter(llc, f[i]);
        }
        str = LinkedListCharactersToArray(llc);
        LinkedListAddString(ll, str);
        FreeLinkedListCharacter(llc);
        llc = CreateLinkedListCharacter();

        found = true;
      }
    }

    if( !found ){
      success = false;
      errorMessage.string = "Unknown token in formula.".split('');
    }
  }

  FreeLinkedListCharacter(llc);
  if(success){
    LinkedListAddString(ll, "<end>".split(''));
    tokens.stringArray = LinkedListStringsToArray(ll);
  }
  FreeLinkedListString(ll);

  return success;
}
function ParseBooleanTokens(tokens, cur, ast, errorMessage){
  var success;

  success = ParseIff(tokens, cur, ast, errorMessage);

  if(success){
    success = TokenIs(tokens, cur, "<end>".split(''));

    if( !success ){
      errorMessage.string = "Expected the end of the formula.".split('');
    }
  }

  return success;
}
function ParseIff(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseImplies(tokens, cur, t, errorMessage);

  for(; success && TokenIs(tokens, cur, "<->".split('')); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseImplies(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseImplies(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseLogicalOr(tokens, cur, t, errorMessage);

  for(; success && TokenIs(tokens, cur, "->".split('')); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseLogicalOr(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseLogicalOr(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseLogicalAnd(tokens, cur, t, errorMessage);

  for(; success && TokenIs(tokens, cur, "|".split('')); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseLogicalAnd(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseLogicalAnd(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseLogicalXor(tokens, cur, t, errorMessage);

  for(; success && TokenIs(tokens, cur, "&".split('')); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseLogicalXor(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseLogicalXor(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseLogicalComparison(tokens, cur, t, errorMessage);

  for(; success && TokenIs(tokens, cur, "^".split('')); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseLogicalComparison(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseLogicalComparison(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseLogicalLiteralVariableNotParenthesis(tokens, cur, t, errorMessage);

  for(; success && (TokenIs(tokens, cur, "=".split('')) || TokenIs(tokens, cur, "!=".split('')) || TokenIs(tokens, cur, "<".split('')) || TokenIs(tokens, cur, "<=".split('')) || TokenIs(tokens, cur, ">".split('')) || TokenIs(tokens, cur, ">=".split(''))); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseLogicalLiteralVariableNotParenthesis(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseLogicalLiteralVariableNotParenthesis(tokens, cur, ast, errorMessage){
  var success;
  var t;
  var token;

  success = true;

  token = Index(tokens, cur);
  if(charIsLetter(token[0]) || charIsNumber(token[0])){
    ast.leaf = true;
    ast.value = token;
    AddToNumberReference(cur, 1);
  }else if(TokenIs(tokens, cur, "(".split(''))){
    AddToNumberReference(cur, 1);

    t = {};
    success = ParseIff(tokens, cur, t, errorMessage);

    if(success){
      ast.value = "()".split('');
      ast.l = t;
      ast.leaf = false;

      success = TokenIs(tokens, cur, ")".split(''));
      if(success){
        AddToNumberReference(cur, 1);
      }else{
        errorMessage.string = "Epected \')\'.".split('');
      }
    }
  }else if(TokenIs(tokens, cur, "!".split(''))){
    AddToNumberReference(cur, 1);

    t = {};
    success = ParseLogicalLiteralVariableNotParenthesis(tokens, cur, t, errorMessage);

    if(success){
      ast.value = "!".split('');
      ast.l = t;
      ast.leaf = false;
    }
  }else{
    success = false;
    errorMessage.string = "Unexpected token.".split('');
  }

  return success;
}
function TokenizeArithmeticFormula(f, tokens, errorMessage){
  var success;
  var i;
  var ll;
  var llc;
  var str;

  success = true;
  ll = CreateLinkedListString();
  llc = CreateLinkedListCharacter();

  for(i = 0; i < f.length && success; ){
    if(f[i] == '('){
      LinkedListAddString(ll, "(".split(''));
      i = i + 1;
    }else if(f[i] == ')'){
      LinkedListAddString(ll, ")".split(''));
      i = i + 1;
    }else if(f[i] == '+'){
      LinkedListAddString(ll, "+".split(''));
      i = i + 1;
    }else if(f[i] == '-'){
      LinkedListAddString(ll, "-".split(''));
      i = i + 1;
    }else if(f[i] == '*'){
      LinkedListAddString(ll, "*".split(''));
      i = i + 1;
    }else if(f[i] == '/'){
      LinkedListAddString(ll, "/".split(''));
      i = i + 1;
    }else if(f[i] == '^'){
      LinkedListAddString(ll, "^".split(''));
      i = i + 1;
    }else if(f[i] == '%'){
      LinkedListAddString(ll, "%".split(''));
      i = i + 1;
    }else if(f[i] == ' ' || f[i] == '\t' || f[i] == '\n'){
      i = i + 1;
    }else if(charIsLetter(f[i])){
      for(; i < f.length && (charIsLetter(f[i]) || charIsNumber(f[i]) || f[i] == '_'); i = i + 1){
        LinkedListAddCharacter(llc, f[i]);
      }
      str = LinkedListCharactersToArray(llc);
      LinkedListAddString(ll, str);
      FreeLinkedListCharacter(llc);
      llc = CreateLinkedListCharacter();
    }else if(charIsNumber(f[i])){
      for(; i < f.length && (charIsNumber(f[i]) || f[i] == '.'); i = i + 1){
        LinkedListAddCharacter(llc, f[i]);
      }
      str = LinkedListCharactersToArray(llc);
      LinkedListAddString(ll, str);
      FreeLinkedListCharacter(llc);
      llc = CreateLinkedListCharacter();
    }else{
      success = false;
      errorMessage.string = "Unknown token in formula.".split('');
    }
  }

  FreeLinkedListCharacter(llc);
  if(success){
    LinkedListAddString(ll, "<end>".split(''));
    tokens.stringArray = LinkedListStringsToArray(ll);
  }
  FreeLinkedListString(ll);

  return success;
}
function ParseArithmeticTokens(tokens, cur, ast, errorMessage){
  var success;

  success = ParseAdditionOrSubtraction(tokens, cur, ast, errorMessage);

  if(success){
    success = TokenIs(tokens, cur, "<end>".split(''));

    if( !success ){
      errorMessage.string = "Expected the end of the formula.".split('');
    }
  }

  return success;
}
function ParseAdditionOrSubtraction(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseMultiplicationOrDivision(tokens, cur, t, errorMessage);

  for(; success && (TokenIs(tokens, cur, "+".split('')) || TokenIs(tokens, cur, "-".split(''))); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseMultiplicationOrDivision(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseMultiplicationOrDivision(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseExponentiation(tokens, cur, t, errorMessage);

  for(; success && (TokenIs(tokens, cur, "*".split('')) || TokenIs(tokens, cur, "/".split('')) || TokenIs(tokens, cur, "mod".split(''))); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseExponentiation(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseExponentiation(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseLiteralVariableUnaryParenthesis(tokens, cur, t, errorMessage);

  if(success && TokenIs(tokens, cur, "^".split(''))){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseExponentiation(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseLiteralVariableUnaryParenthesis(tokens, cur, ast, errorMessage){
  var success;
  var t;
  var token;

  success = true;

  token = Index(tokens, cur);
  if(IsKnownArithmeticFunction(token)){
    AddToNumberReference(cur, 1);

    success = TokenIs(tokens, cur, "(".split(''));
    if(success){
      AddToNumberReference(cur, 1);

      t = {};
      success = ParseAdditionOrSubtraction(tokens, cur, t, errorMessage);

      if(success){
        success = TokenIs(tokens, cur, ")".split(''));
        if(success){
          ast.leaf = false;
          ast.value = token;
          ast.l = t;

          AddToNumberReference(cur, 1);
        }else{
          errorMessage.string = "Epected \')\'.".split('');
        }
      }
    }else{
      errorMessage.string = "Epected \'(\'.".split('');
    }
  }else if(charIsLetter(token[0])){
    ast.leaf = true;
    ast.value = token;
    AddToNumberReference(cur, 1);
  }else if(charIsNumber(token[0])){
    if(NextTokenIs(tokens, cur, "%".split(''))){
      ast.leaf = false;
      ast.value = "%".split('');
      ast.l = {};
      ast.l.leaf = true;
      ast.l.value = token;
      AddToNumberReference(cur, 1);
      AddToNumberReference(cur, 1);
    }else{
      ast.leaf = true;
      ast.value = token;
      AddToNumberReference(cur, 1);
    }
  }else if(TokenIs(tokens, cur, "(".split(''))){
    AddToNumberReference(cur, 1);

    t = {};
    success = ParseAdditionOrSubtraction(tokens, cur, t, errorMessage);

    if(success){
      ast.value = "()".split('');
      ast.l = t;
      ast.leaf = false;

      success = TokenIs(tokens, cur, ")".split(''));
      if(success){
        AddToNumberReference(cur, 1);
      }else{
        errorMessage.string = "Epected \')\'.".split('');
      }
    }
  }else if(TokenIs(tokens, cur, "-".split('')) || TokenIs(tokens, cur, "+".split(''))){
    AddToNumberReference(cur, 1);

    t = {};
    success = ParseExponentiation(tokens, cur, t, errorMessage);

    if(success){
      if(arraysStringsEqual(token, "-".split(''))){
        ast.value = "unary-".split('');
      }else{
        ast.value = "unary+".split('');
      }
      ast.l = t;
      ast.leaf = false;
    }
  }else{
    success = false;
    errorMessage.string = "Unexpected token.".split('');
  }

  return success;
}
function IsKnownArithmeticFunction(token){
  return arraysStringsEqual(token, "sqrt".split('')) || arraysStringsEqual(token, "ceil".split('')) || arraysStringsEqual(token, "floor".split('')) || arraysStringsEqual(token, "truncate".split('')) || arraysStringsEqual(token, "abs".split('')) || arraysStringsEqual(token, "log".split('')) || arraysStringsEqual(token, "ln".split('')) || arraysStringsEqual(token, "exp".split('')) || arraysStringsEqual(token, "sin".split('')) || arraysStringsEqual(token, "cos".split('')) || arraysStringsEqual(token, "tan".split('')) || arraysStringsEqual(token, "asin".split('')) || arraysStringsEqual(token, "acos".split('')) || arraysStringsEqual(token, "atan".split(''));
}
function IsKnownMatrixFunction(token){
  return arraysStringsEqual(token, "trace".split('')) || arraysStringsEqual(token, "inverse".split('')) || arraysStringsEqual(token, "norm".split('')) || arraysStringsEqual(token, "minor".split(''));
}
function TokenizeBitwiseFormula(f, tokens, errorMessage){
  var success;
  var i;
  var ll;
  var llc;
  var str;

  success = true;
  ll = CreateLinkedListString();
  llc = CreateLinkedListCharacter();

  for(i = 0; i < f.length && success; ){
    if(f[i] == '('){
      LinkedListAddString(ll, "(".split(''));
      i = i + 1;
    }else if(f[i] == ')'){
      LinkedListAddString(ll, ")".split(''));
      i = i + 1;
    }else if(f[i] == '~'){
      LinkedListAddString(ll, "~".split(''));
      i = i + 1;
    }else if(f[i] == '&'){
      LinkedListAddString(ll, "&".split(''));
      i = i + 1;
    }else if(f[i] == '^'){
      LinkedListAddString(ll, "^".split(''));
      i = i + 1;
    }else if(f[i] == '|'){
      LinkedListAddString(ll, "|".split(''));
      i = i + 1;
    }else if(f[i] == ' ' || f[i] == '\t' || f[i] == '\n'){
      i = i + 1;
    }else if(charIsLetter(f[i])){
      for(; i < f.length && (charIsLetter(f[i]) || charIsNumber(f[i]) || f[i] == '_'); i = i + 1){
        LinkedListAddCharacter(llc, f[i]);
      }
      str = LinkedListCharactersToArray(llc);
      LinkedListAddString(ll, str);
      FreeLinkedListCharacter(llc);
      llc = CreateLinkedListCharacter();
    }else if(charIsNumber(f[i])){
      for(; i < f.length && (charIsNumber(f[i]) || f[i] == '.'); i = i + 1){
        LinkedListAddCharacter(llc, f[i]);
      }
      str = LinkedListCharactersToArray(llc);
      LinkedListAddString(ll, str);
      FreeLinkedListCharacter(llc);
      llc = CreateLinkedListCharacter();
    }else if(i + 1 < f.length){
      if(f[i] == '>' && f[i + 1] == '>'){
        LinkedListAddString(ll, ">>".split(''));
        i = i + 2;
      }else if(f[i] == '<' && f[i + 1] == '<'){
        LinkedListAddString(ll, "<<".split(''));
        i = i + 2;
      }else{
        success = false;
        errorMessage.string = "Unknown token in formula.".split('');
      }
    }else{
      success = false;
      errorMessage.string = "Unknown token in formula.".split('');
    }
  }

  FreeLinkedListCharacter(llc);
  if(success){
    LinkedListAddString(ll, "<end>".split(''));
    tokens.stringArray = LinkedListStringsToArray(ll);
  }
  FreeLinkedListString(ll);

  return success;
}
function ParseBitwiseTokens(tokens, cur, ast, errorMessage){
  var success;

  success = ParseOr(tokens, cur, ast, errorMessage);

  if(success){
    success = TokenIs(tokens, cur, "<end>".split(''));

    if( !success ){
      errorMessage.string = "Expected the end of the formula.".split('');
    }
  }

  return success;
}
function ParseOr(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseXor(tokens, cur, t, errorMessage);

  for(; success && TokenIs(tokens, cur, "|".split('')); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseXor(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseXor(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseAnd(tokens, cur, t, errorMessage);

  for(; success && TokenIs(tokens, cur, "^".split('')); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseAnd(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseAnd(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseShift(tokens, cur, t, errorMessage);

  for(; success && TokenIs(tokens, cur, "&".split('')); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseShift(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseShift(tokens, cur, ast, errorMessage){
  var success;
  var t, t1;
  var op;

  t = {};
  success = ParseLiteralVariableNotParenthesis(tokens, cur, t, errorMessage);

  for(; success && (TokenIs(tokens, cur, "<<".split('')) || TokenIs(tokens, cur, ">>".split(''))); ){
    op = Index(tokens, cur);
    AddToNumberReference(cur, 1);
    t1 = {};
    success = ParseLiteralVariableNotParenthesis(tokens, cur, t1, errorMessage);
    if(success){
      t = CreateASTNode(t, t1, op);
    }
  }

  if(success){
    AssignASTNode(ast, t);
  }

  return success;
}
function ParseLiteralVariableNotParenthesis(tokens, cur, ast, errorMessage){
  var success;
  var t;
  var token;

  success = true;

  token = Index(tokens, cur);
  if(charIsLetter(token[0]) || charIsNumber(token[0])){
    ast.leaf = true;
    ast.value = token;
    AddToNumberReference(cur, 1);
  }else if(TokenIs(tokens, cur, "(".split(''))){
    AddToNumberReference(cur, 1);

    t = {};
    success = ParseOr(tokens, cur, t, errorMessage);

    if(success){
      ast.value = "()".split('');
      ast.l = t;
      ast.leaf = false;

      success = TokenIs(tokens, cur, ")".split(''));
      if(success){
        AddToNumberReference(cur, 1);
      }else{
        errorMessage.string = "Epected \')\'.".split('');
      }
    }
  }else if(TokenIs(tokens, cur, "~".split(''))){
    AddToNumberReference(cur, 1);

    t = {};
    success = ParseLiteralVariableNotParenthesis(tokens, cur, t, errorMessage);

    if(success){
      ast.value = "~".split('');
      ast.l = t;
      ast.leaf = false;
    }
  }else{
    success = false;
    errorMessage.string = "Unexpected token.".split('');
  }

  return success;
}
function ASTToTFormFunctions(ast, tf, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target){
  var t;
  var assignedT;

  t = CreateBooleanArrayReferenceLengthValue(0, false);
  assignedT = CreateNumberReference(0);
  tf.string = [];
  tf.string.length = 0;

  ASTToTFormFunctionsInner(ast, tf, t, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, 0);
}
function ASTToTFormFunctionsInner(ast, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level){
  var tl, tr, t;
  var functionName, value, numberString;

  tl = 0;
  tr = 0;

  if( !ast.leaf ){
    if(arraysStringsEqual(ast.value, "+".split('')) || arraysStringsEqual(ast.value, "-".split('')) || arraysStringsEqual(ast.value, "mod".split('')) || arraysStringsEqual(ast.value, "*".split('')) || arraysStringsEqual(ast.value, "/".split('')) || arraysStringsEqual(ast.value, "^".split(''))){
      if( !ast.l.leaf ){
        ASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1);
        tl = assignedT.numberValue;
      }

      if( !ast.r.leaf ){
        ASTToTFormFunctionsInner(ast.r, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1);
        tr = assignedT.numberValue;
      }

      if( !ast.l.leaf ){
        FreeTVariable(ts, tl);
      }

      if( !ast.r.leaf ){
        FreeTVariable(ts, tr);
      }

      functionName = ArithmeticBinarySymbolToFunctionName(ast.value);

      tf.string = AppendString(tf.string, prefix);
      tf.string = AppendString(tf.string, functionName);
      tf.string = AppendString(tf.string, postfix);
      if(parenthesis){
        tf.string = AppendString(tf.string, "(".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }

      if(level > 0 || target.length == 0){
        t = AllocateTVariable(ts);
        assignedT.numberValue = t;
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(t);
        tf.string = AppendString(tf.string, numberString);
      }else{
        tf.string = AppendString(tf.string, target);
      }

      tf.string = AppendString(tf.string, ", ".split(''));

      if(ast.l.leaf){
        if(charIsNumber(ast.l.value[0])){
          value = [];
          value.length = 0;
          if(wrappedNumber){
            value = AppendString(value, prefix);
            value = AppendString(value, "Number".split(''));
            value = AppendString(value, postfix);
            value = AppendString(value, "(".split(''));
          }
          value = AppendString(value, ast.l.value);
          if(wrappedNumber){
            value = AppendString(value, ")".split(''));
          }
        }else{
          value = ast.l.value;
        }
        tf.string = AppendString(tf.string, value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tl);
        tf.string = AppendString(tf.string, numberString);
      }
      tf.string = AppendString(tf.string, ", ".split(''));
      if(ast.r.leaf){
        if(charIsNumber(ast.r.value[0])){
          value = [];
          value.length = 0;
          if(wrappedNumber){
            value = AppendString(value, prefix);
            value = AppendString(value, "Number".split(''));
            value = AppendString(value, postfix);
            value = AppendString(value, "(".split(''));
          }
          value = AppendString(value, ast.r.value);
          if(wrappedNumber){
            value = AppendString(value, ")".split(''));
          }
        }else{
          value = ast.r.value;
        }
        tf.string = AppendString(tf.string, value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tr);
        tf.string = AppendString(tf.string, numberString);
      }
      if(parenthesis){
        tf.string = AppendString(tf.string, ")".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }
      if(semicolon){
        tf.string = AppendString(tf.string, ";".split(''));
      }
      tf.string = AppendString(tf.string, "\n".split(''));
    }else if(arraysStringsEqual(ast.value, "()".split(''))){
      ASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1);
    }else if(arraysStringsEqual(ast.value, "unary-".split('')) || arraysStringsEqual(ast.value, "unary+".split(''))){
      if( !ast.l.leaf ){
        ASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1);
        tl = assignedT.numberValue;
        FreeTVariable(ts, tl);
      }

      functionName = ArithmeticBinarySymbolToFunctionName(ast.value);

      tf.string = AppendString(tf.string, prefix);
      tf.string = AppendString(tf.string, functionName);
      tf.string = AppendString(tf.string, postfix);
      if(parenthesis){
        tf.string = AppendString(tf.string, "(".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }

      if(level > 0 || target.length == 0){
        t = AllocateTVariable(ts);
        assignedT.numberValue = t;
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(t);
        tf.string = AppendString(tf.string, numberString);
      }else{
        tf.string = AppendString(tf.string, target);
      }

      tf.string = AppendString(tf.string, ", ".split(''));

      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tl);
        tf.string = AppendString(tf.string, numberString);
      }
      if(parenthesis){
        tf.string = AppendString(tf.string, ")".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }
      if(semicolon){
        tf.string = AppendString(tf.string, ";".split(''));
      }
      tf.string = AppendString(tf.string, "\n".split(''));
    }else if(IsKnownArithmeticFunction(ast.value)){
      if( !ast.l.leaf ){
        ASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1);
        tl = assignedT.numberValue;
        FreeTVariable(ts, tl);
      }

      functionName = arraysCopyString(ast.value);
      functionName[0] = charToUpperCase(functionName[0]);

      tf.string = AppendString(tf.string, prefix);
      tf.string = AppendString(tf.string, functionName);
      tf.string = AppendString(tf.string, postfix);
      if(parenthesis){
        tf.string = AppendString(tf.string, "(".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }

      if(level > 0 || target.length == 0){
        t = AllocateTVariable(ts);
        assignedT.numberValue = t;
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(t);
        tf.string = AppendString(tf.string, numberString);
      }else{
        tf.string = AppendString(tf.string, target);
      }

      tf.string = AppendString(tf.string, ", ".split(''));

      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tl);
        tf.string = AppendString(tf.string, numberString);
      }
      if(parenthesis){
        tf.string = AppendString(tf.string, ")".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }
      if(semicolon){
        tf.string = AppendString(tf.string, ";".split(''));
      }
      tf.string = AppendString(tf.string, "\n".split(''));
    }else if(arraysStringsEqual(ast.value, "%".split(''))){
      tf.string = AppendString(tf.string, prefix);
      tf.string = AppendString(tf.string, "Percentage".split(''));
      tf.string = AppendString(tf.string, postfix);
      if(parenthesis){
        tf.string = AppendString(tf.string, "(".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }

      if(level > 0 || target.length == 0){
        t = AllocateTVariable(ts);
        assignedT.numberValue = t;
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(t);
        tf.string = AppendString(tf.string, numberString);
      }else{
        tf.string = AppendString(tf.string, target);
      }

      tf.string = AppendString(tf.string, ", ".split(''));

      tf.string = AppendString(tf.string, ast.l.value);
      if(parenthesis){
        tf.string = AppendString(tf.string, ")".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }
      if(semicolon){
        tf.string = AppendString(tf.string, ";".split(''));
      }
      tf.string = AppendString(tf.string, "\n".split(''));
    }else{
      tf.string = AppendString(tf.string, "<failed>".split(''));
    }
  }else{
    tf.string = AppendString(tf.string, "<failed>".split(''));
  }
}
function ArithmeticBinarySymbolToFunctionName(value){
  var f;

  f = "Unknown".split('');

  if(arraysStringsEqual(value, "+".split(''))){
    f = "Add".split('');
  }
  if(arraysStringsEqual(value, "-".split(''))){
    f = "Sub".split('');
  }
  if(arraysStringsEqual(value, "mod".split(''))){
    f = "Mod".split('');
  }
  if(arraysStringsEqual(value, "*".split(''))){
    f = "Mul".split('');
  }
  if(arraysStringsEqual(value, "/".split(''))){
    f = "Div".split('');
  }
  if(arraysStringsEqual(value, "^".split(''))){
    f = "Pow".split('');
  }
  if(arraysStringsEqual(value, "unary-".split(''))){
    f = "Negate".split('');
  }
  if(arraysStringsEqual(value, "unary+".split(''))){
    f = "Positive".split('');
  }

  return f;
}
function ArithmeticFormulaToTFormFunctions(f, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, result, message){
  var tokens;
  var success;
  var ast;
  var pos;

  tokens = {};
  success = TokenizeArithmeticFormula(f, tokens, message);

  if(success){
    /* Parse */
    ast = {};
    pos = CreateNumberReference(0);
    success = ParseArithmeticTokens(tokens, pos, ast, message);

    if(success){
      ASTToTFormFunctions(ast, result, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target);
    }
  }

  return success;
}
function AllocateTVariable(ts){
  var i, newT;
  var found;
  var newArray;

  newT = 0;
  found = false;

  for(i = 0; i < ts.booleanArray.length &&  !found ; i = i + 1){
    if( !ts.booleanArray[i] ){
      found = true;
      newT = i;
    }
  }

  if(found){
  }else{
    newT = i;
    newArray = [];
    newArray.length = ts.booleanArray.length + 1;
    for(i = 0; i < ts.booleanArray.length; i = i + 1){
      newArray[i] = ts.booleanArray[i];
    }
    newArray[newT] = false;
    delete(ts.booleanArray);
    ts.booleanArray = newArray;
  }

  /* Mark as allocated: */
  ts.booleanArray[newT] = true;

  return newT;
}
function FreeTVariable(ts, t){
  ts.booleanArray[t] = false;
}
function ASTToBooleanFormula(ast){
  var f, p1, p2;

  if(ast.leaf){
    f = ast.value;
  }else if(arraysStringsEqual(ast.value, "!".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToBooleanFormula(ast.l);
    f = AppendString(f, "!".split(''));
    f = AppendString(f, p1);
  }else if(arraysStringsEqual(ast.value, "()".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToBooleanFormula(ast.l);
    f = AppendString(f, "(".split(''));
    f = AppendString(f, p1);
    f = AppendString(f, ")".split(''));
  }else if(arraysStringsEqual(ast.value, "&".split('')) || arraysStringsEqual(ast.value, "|".split('')) || arraysStringsEqual(ast.value, "^".split('')) || arraysStringsEqual(ast.value, "=".split('')) || arraysStringsEqual(ast.value, "!=".split('')) || arraysStringsEqual(ast.value, "<".split('')) || arraysStringsEqual(ast.value, "<=".split('')) || arraysStringsEqual(ast.value, ">".split('')) || arraysStringsEqual(ast.value, ">=".split('')) || arraysStringsEqual(ast.value, "->".split('')) || arraysStringsEqual(ast.value, "<->".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToBooleanFormula(ast.l);
    p2 = ASTToBooleanFormula(ast.r);
    f = AppendString(f, p1);
    f = AppendString(f, " ".split(''));
    f = AppendString(f, ast.value);
    f = AppendString(f, " ".split(''));
    f = AppendString(f, p2);
  }else{
    f = "<failed>".split('');
  }

  return f;
}
function BooleanASTToTForm(ast, tf, t){
  var tl, tr;
  var numberString;
  numberString = {};

  tl = 0;
  tr = 0;

  if( !ast.leaf ){
    if(arraysStringsEqual(ast.value, "&".split('')) || arraysStringsEqual(ast.value, "|".split('')) || arraysStringsEqual(ast.value, "^".split('')) || arraysStringsEqual(ast.value, "=".split('')) || arraysStringsEqual(ast.value, "!=".split('')) || arraysStringsEqual(ast.value, "<".split('')) || arraysStringsEqual(ast.value, "<=".split('')) || arraysStringsEqual(ast.value, ">".split('')) || arraysStringsEqual(ast.value, ">=".split('')) || arraysStringsEqual(ast.value, "->".split('')) || arraysStringsEqual(ast.value, "<->".split(''))){
      if( !ast.l.leaf ){
        BooleanASTToTForm(ast.l, tf, t);
        tl = t.numberValue;
      }

      if( !ast.r.leaf ){
        BooleanASTToTForm(ast.r, tf, t);
        tr = t.numberValue;
      }

      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = ".split(''));
      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tl, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, " ".split(''));
      tf.string = AppendString(tf.string, ast.value);
      tf.string = AppendString(tf.string, " ".split(''));
      if(ast.r.leaf){
        tf.string = AppendString(tf.string, ast.r.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tr, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else if(arraysStringsEqual(ast.value, "()".split(''))){
      BooleanASTToTForm(ast.l, tf, t);
      tl = t.numberValue;

      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = ".split(''));
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(tl, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else if(arraysStringsEqual(ast.value, "!".split(''))){
      if( !ast.l.leaf ){
        BooleanASTToTForm(ast.l, tf, t);
        tl = t.numberValue;
      }

      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = ".split(''));
      tf.string = AppendString(tf.string, "!".split(''));
      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tl, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else{
      tf.string = AppendString(tf.string, "<failed>".split(''));
    }
  }
}
function BooleanFormulaToTForm(f){
  var af;
  var tokens;
  var success;
  var errorMessage, tf;
  var ast;
  var pos, t;

  tokens = {};
  errorMessage = {};
  success = TokenizeBooleanFormula(f, tokens, errorMessage);

  if(success){
    /* Parse */
    ast = {};
    pos = CreateNumberReference(0);
    success = ParseBooleanTokens(tokens, pos, ast, errorMessage);

    if(success){
      tf = CreateStringReference("".split(''));
      t = CreateNumberReference(0);
      BooleanASTToTForm(ast, tf, t);
      af = tf.string;
    }else{
      af = errorMessage.string;
    }
  }else{
    af = errorMessage.string;
  }

  return af;
}
function BitwiseASTToTFormFunctions(ast, tf, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target){
  var t;
  var assignedT;

  t = CreateBooleanArrayReferenceLengthValue(0, false);
  assignedT = CreateNumberReference(0);
  tf.string = [];
  tf.string.length = 0;

  BitwiseASTToTFormFunctionsInner(ast, tf, t, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, 0);
}
function BitwiseASTToTFormFunctionsInner(ast, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level){
  var tl, tr, t;
  var functionName, value, numberString;

  tl = 0;
  tr = 0;
  t = 0;

  if( !ast.leaf ){
    if(arraysStringsEqual(ast.value, "&".split('')) || arraysStringsEqual(ast.value, "|".split('')) || arraysStringsEqual(ast.value, "^".split('')) || arraysStringsEqual(ast.value, "<<".split('')) || arraysStringsEqual(ast.value, ">>".split(''))){
      if( !ast.l.leaf ){
        BitwiseASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1);
        tl = assignedT.numberValue;
      }

      if( !ast.r.leaf ){
        BitwiseASTToTFormFunctionsInner(ast.r, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1);
        tr = assignedT.numberValue;
      }

      if( !ast.l.leaf ){
        FreeTVariable(ts, tl);
      }

      if( !ast.r.leaf ){
        FreeTVariable(ts, tr);
      }

      functionName = BitwiseBinarySymbolToFunctionName(ast.value);

      tf.string = AppendString(tf.string, prefix);
      tf.string = AppendString(tf.string, functionName);
      tf.string = AppendString(tf.string, postfix);
      if(parenthesis){
        tf.string = AppendString(tf.string, "(".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }

      if(level > 0 || target.length == 0){
        t = AllocateTVariable(ts);
        assignedT.numberValue = t;
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(t);
        tf.string = AppendString(tf.string, numberString);
      }else{
        tf.string = AppendString(tf.string, target);
      }

      tf.string = AppendString(tf.string, ", ".split(''));

      if(ast.l.leaf){
        if(charIsNumber(ast.l.value[0])){
          value = [];
          value.length = 0;
          value = AppendString(value, prefix);
          if(wrappedNumber){
            value = AppendString(value, "Number".split(''));
            value = AppendString(value, postfix);
            value = AppendString(value, "(".split(''));
          }
          value = AppendString(value, ast.l.value);
          if(wrappedNumber){
            value = AppendString(value, ")".split(''));
          }
        }else{
          value = ast.l.value;
        }
        tf.string = AppendString(tf.string, value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tl);
        tf.string = AppendString(tf.string, numberString);
      }
      tf.string = AppendString(tf.string, ", ".split(''));
      if(ast.r.leaf){
        if(charIsNumber(ast.r.value[0])){
          value = [];
          value.length = 0;
          value = AppendString(value, prefix);
          if(wrappedNumber){
            value = AppendString(value, "Number".split(''));
            value = AppendString(value, postfix);
            value = AppendString(value, "(".split(''));
          }
          value = AppendString(value, ast.r.value);
          if(wrappedNumber){
            value = AppendString(value, ")".split(''));
          }
        }else{
          value = ast.r.value;
        }
        tf.string = AppendString(tf.string, value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tr);
        tf.string = AppendString(tf.string, numberString);
      }
      if(parenthesis){
        tf.string = AppendString(tf.string, ")".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }
      if(semicolon){
        tf.string = AppendString(tf.string, ";".split(''));
      }
      tf.string = AppendString(tf.string, "\n".split(''));
    }else if(arraysStringsEqual(ast.value, "()".split(''))){
      BitwiseASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1);
    }else if(arraysStringsEqual(ast.value, "~".split(''))){
      if( !ast.l.leaf ){
        BitwiseASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1);
        tl = assignedT.numberValue;
        FreeTVariable(ts, tl);
      }

      functionName = BitwiseBinarySymbolToFunctionName(ast.value);

      tf.string = AppendString(tf.string, prefix);
      tf.string = AppendString(tf.string, functionName);
      tf.string = AppendString(tf.string, postfix);
      if(parenthesis){
        tf.string = AppendString(tf.string, "(".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }

      if(level > 0 || target.length == 0){
        t = AllocateTVariable(ts);
        assignedT.numberValue = t;
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(t);
        tf.string = AppendString(tf.string, numberString);
      }else{
        tf.string = AppendString(tf.string, target);
      }

      tf.string = AppendString(tf.string, ", ".split(''));

      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tl);
        tf.string = AppendString(tf.string, numberString);
      }
      if(parenthesis){
        tf.string = AppendString(tf.string, ")".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }
      if(semicolon){
        tf.string = AppendString(tf.string, ";".split(''));
      }
      tf.string = AppendString(tf.string, "\n".split(''));
    }else{
      tf.string = AppendString(tf.string, "<failed>".split(''));
    }
  }else{
    tf.string = AppendString(tf.string, "<failed>".split(''));
  }
}
function BitwiseBinarySymbolToFunctionName(value){
  var f;

  f = "Unknown".split('');

  if(arraysStringsEqual(value, "~".split(''))){
    f = "Not".split('');
  }
  if(arraysStringsEqual(value, "&".split(''))){
    f = "And".split('');
  }
  if(arraysStringsEqual(value, "|".split(''))){
    f = "Or".split('');
  }
  if(arraysStringsEqual(value, "^".split(''))){
    f = "Xor".split('');
  }
  if(arraysStringsEqual(value, "<<".split(''))){
    f = "ShiftLeft".split('');
  }
  if(arraysStringsEqual(value, ">>".split(''))){
    f = "ShiftRight".split('');
  }

  return f;
}
function BitwiseFormulaToTFormFunctions(f, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, tf, message){
  var tokens;
  var success;
  var ast;
  var pos;

  tokens = {};
  success = TokenizeBitwiseFormula(f, tokens, message);

  if(success){
    /* Parse */
    ast = {};
    pos = CreateNumberReference(0);
    success = ParseBitwiseTokens(tokens, pos, ast, message);

    if(success){
      BitwiseASTToTFormFunctions(ast, tf, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target);
    }
  }

  return success;
}
function AddToNumberReference(cur, val){
  cur.numberValue = cur.numberValue + val;
}
function TokenIs(tokens, cur, s){
  return arraysStringsEqual(Index(tokens, cur), s);
}
function NextTokenIs(tokens, cur, s){
  return arraysStringsEqual(NextIndex(tokens, cur), s);
}
function NextIndex(stringArrayReference, index){
  return stringArrayReference.stringArray[index.numberValue + 1].string;
}
function Index(stringArrayReference, index){
  return stringArrayReference.stringArray[index.numberValue].string;
}
function AssignASTNode(x, a){
  x.leaf = a.leaf;
  x.l = a.l;
  x.r = a.r;
  x.value = a.value;
}
function CreateASTNode(l, r, op){
  var t;

  t = {};
  t.value = op;
  t.l = l;
  t.r = r;
  t.leaf = false;

  return t;
}
function ASTToArithmeticFormula(ast){
  var f, p1, p2;

  if(ast.leaf){
    f = ast.value;
  }else if(arraysStringsEqual(ast.value, "unary-".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToArithmeticFormula(ast.l);
    f = AppendString(f, "-".split(''));
    f = AppendString(f, p1);
  }else if(arraysStringsEqual(ast.value, "unary+".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToArithmeticFormula(ast.l);
    f = AppendString(f, "+".split(''));
    f = AppendString(f, p1);
  }else if(arraysStringsEqual(ast.value, "%".split(''))){
    f = [];
    f.length = 0;
    f = AppendString(f, ast.l.value);
    f = AppendString(f, "%".split(''));
  }else if(IsKnownArithmeticFunction(ast.value)){
    f = [];
    f.length = 0;
    p1 = ASTToArithmeticFormula(ast.l);
    f = AppendString(f, ast.value);
    f = AppendString(f, "(".split(''));
    f = AppendString(f, p1);
    f = AppendString(f, ")".split(''));
  }else if(arraysStringsEqual(ast.value, "()".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToArithmeticFormula(ast.l);
    f = AppendString(f, "(".split(''));
    f = AppendString(f, p1);
    f = AppendString(f, ")".split(''));
  }else if(arraysStringsEqual(ast.value, "+".split('')) || arraysStringsEqual(ast.value, "-".split('')) || arraysStringsEqual(ast.value, "mod".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToArithmeticFormula(ast.l);
    p2 = ASTToArithmeticFormula(ast.r);
    f = AppendString(f, p1);
    f = AppendString(f, " ".split(''));
    f = AppendString(f, ast.value);
    f = AppendString(f, " ".split(''));
    f = AppendString(f, p2);
  }else if(arraysStringsEqual(ast.value, "*".split('')) || arraysStringsEqual(ast.value, "/".split('')) || arraysStringsEqual(ast.value, "^".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToArithmeticFormula(ast.l);
    p2 = ASTToArithmeticFormula(ast.r);
    f = AppendString(f, p1);
    f = AppendString(f, ast.value);
    f = AppendString(f, p2);
  }else{
    f = "<failed>".split('');
  }

  return f;
}
function ArithmeticASTToTForm(ast, tf, t){
  var tl, tr;
  var numberString;
  numberString = {};

  tl = 0;
  tr = 0;

  if( !ast.leaf ){
    if(arraysStringsEqual(ast.value, "+".split('')) || arraysStringsEqual(ast.value, "-".split('')) || arraysStringsEqual(ast.value, "mod".split('')) || arraysStringsEqual(ast.value, "*".split('')) || arraysStringsEqual(ast.value, "/".split('')) || arraysStringsEqual(ast.value, "^".split(''))){
      if( !ast.l.leaf ){
        ArithmeticASTToTForm(ast.l, tf, t);
        tl = t.numberValue;
      }

      if( !ast.r.leaf ){
        ArithmeticASTToTForm(ast.r, tf, t);
        tr = t.numberValue;
      }

      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = ".split(''));
      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tl, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, " ".split(''));
      tf.string = AppendString(tf.string, ast.value);
      tf.string = AppendString(tf.string, " ".split(''));
      if(ast.r.leaf){
        tf.string = AppendString(tf.string, ast.r.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tr, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else if(arraysStringsEqual(ast.value, "()".split(''))){
      ArithmeticASTToTForm(ast.l, tf, t);
    }else if(arraysStringsEqual(ast.value, "unary-".split('')) || arraysStringsEqual(ast.value, "unary+".split(''))){
      if( !ast.l.leaf ){
        ArithmeticASTToTForm(ast.l, tf, t);
        tl = t.numberValue;
      }

      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = ".split(''));
      if(arraysStringsEqual(ast.value, "unary-".split(''))){
        tf.string = AppendString(tf.string, "-".split(''));
      }else{
        tf.string = AppendString(tf.string, "+".split(''));
      }
      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tl, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else if(IsKnownArithmeticFunction(ast.value)){
      if( !ast.l.leaf ){
        ArithmeticASTToTForm(ast.l, tf, t);
        tl = t.numberValue;
      }

      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = ".split(''));
      tf.string = AppendString(tf.string, ast.value);
      tf.string = AppendString(tf.string, "(".split(''));
      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tl, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, ")".split(''));
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else if(arraysStringsEqual(ast.value, "%".split(''))){
      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = Percentage(".split(''));
      tf.string = AppendString(tf.string, ast.l.value);
      tf.string = AppendString(tf.string, ")".split(''));
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else{
      tf.string = AppendString(tf.string, "<failed>".split(''));
    }
  }
}
function ArithmeticFormulaToTForm(f){
  var af;
  var tokens;
  var success;
  var errorMessage, tf;
  var ast;
  var pos, t;

  tokens = {};
  errorMessage = {};
  success = TokenizeArithmeticFormula(f, tokens, errorMessage);

  if(success){
    /* Parse */
    ast = {};
    pos = CreateNumberReference(0);
    success = ParseArithmeticTokens(tokens, pos, ast, errorMessage);

    if(success){
      tf = CreateStringReference("".split(''));
      t = CreateNumberReference(0);
      ArithmeticASTToTForm(ast, tf, t);
      af = tf.string;
    }else{
      af = errorMessage.string;
    }
  }else{
    af = errorMessage.string;
  }

  return af;
}
function ASTToBitwiseFormula(ast){
  var f, p1, p2;

  if(ast.leaf){
    f = ast.value;
  }else if(arraysStringsEqual(ast.value, "~".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToBitwiseFormula(ast.l);
    f = AppendString(f, "~".split(''));
    f = AppendString(f, p1);
  }else if(arraysStringsEqual(ast.value, "()".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToBitwiseFormula(ast.l);
    f = AppendString(f, "(".split(''));
    f = AppendString(f, p1);
    f = AppendString(f, ")".split(''));
  }else if(arraysStringsEqual(ast.value, "&".split('')) || arraysStringsEqual(ast.value, "|".split('')) || arraysStringsEqual(ast.value, "^".split('')) || arraysStringsEqual(ast.value, "<<".split('')) || arraysStringsEqual(ast.value, ">>".split(''))){
    f = [];
    f.length = 0;
    p1 = ASTToBitwiseFormula(ast.l);
    p2 = ASTToBitwiseFormula(ast.r);
    f = AppendString(f, p1);
    f = AppendString(f, " ".split(''));
    f = AppendString(f, ast.value);
    f = AppendString(f, " ".split(''));
    f = AppendString(f, p2);
  }else{
    f = "<failed>".split('');
  }

  return f;
}
function BitwiseASTToTForm(ast, tf, t){
  var tl, tr;
  var numberString;
  numberString = {};

  tl = 0;
  tr = 0;

  if( !ast.leaf ){
    if(arraysStringsEqual(ast.value, "&".split('')) || arraysStringsEqual(ast.value, "|".split('')) || arraysStringsEqual(ast.value, "^".split('')) || arraysStringsEqual(ast.value, "<<".split('')) || arraysStringsEqual(ast.value, ">>".split(''))){
      if( !ast.l.leaf ){
        BitwiseASTToTForm(ast.l, tf, t);
        tl = t.numberValue;
      }

      if( !ast.r.leaf ){
        BitwiseASTToTForm(ast.r, tf, t);
        tr = t.numberValue;
      }

      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = ".split(''));
      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tl, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, " ".split(''));
      tf.string = AppendString(tf.string, ast.value);
      tf.string = AppendString(tf.string, " ".split(''));
      if(ast.r.leaf){
        tf.string = AppendString(tf.string, ast.r.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tr, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else if(arraysStringsEqual(ast.value, "()".split(''))){
      BitwiseASTToTForm(ast.l, tf, t);
      tl = t.numberValue;

      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = ".split(''));
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(tl, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else if(arraysStringsEqual(ast.value, "!".split(''))){
      if( !ast.l.leaf ){
        BitwiseASTToTForm(ast.l, tf, t);
        tl = t.numberValue;
      }

      t.numberValue = t.numberValue + 1;
      tf.string = AppendString(tf.string, "t".split(''));
      CreateStringFromNumberWithCheck(t.numberValue, 10, numberString);
      tf.string = AppendString(tf.string, numberString.string);
      tf.string = AppendString(tf.string, " = ".split(''));
      tf.string = AppendString(tf.string, "!".split(''));
      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        CreateStringFromNumberWithCheck(tl, 10, numberString);
        tf.string = AppendString(tf.string, numberString.string);
      }
      tf.string = AppendString(tf.string, ";\n".split(''));
    }else{
      tf.string = AppendString(tf.string, "<failed>".split(''));
    }
  }
}
function BitwiseFormulaToTForm(f){
  var af;
  var tokens;
  var success;
  var errorMessage, tf;
  var ast;
  var pos, t;

  tokens = {};
  errorMessage = {};
  success = TokenizeBitwiseFormula(f, tokens, errorMessage);

  if(success){
    /* Parse */
    ast = {};
    pos = CreateNumberReference(0);
    success = ParseBitwiseTokens(tokens, pos, ast, errorMessage);

    if(success){
      tf = CreateStringReference("".split(''));
      t = CreateNumberReference(0);
      BitwiseASTToTForm(ast, tf, t);
      af = tf.string;
    }else{
      af = errorMessage.string;
    }
  }else{
    af = errorMessage.string;
  }

  return af;
}
function BooleanASTToTFormFunctions(ast, tf, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, endsWithIf){
  var t;
  var assignedT;

  t = CreateBooleanArrayReferenceLengthValue(0, false);
  assignedT = CreateNumberReference(0);
  tf.string = [];
  tf.string.length = 0;

  BooleanASTToTFormFunctionsInner(ast, tf, t, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, 0, endsWithIf);
}
function BooleanASTToTFormFunctionsInner(ast, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level, endsWithIf){
  var tl, tr, t;
  var functionName, value, numberString;

  tl = 0;
  tr = 0;
  t = 0;

  if( !ast.leaf ){
    if(arraysStringsEqual(ast.value, "&".split('')) || arraysStringsEqual(ast.value, "|".split('')) || arraysStringsEqual(ast.value, "^".split('')) || arraysStringsEqual(ast.value, "=".split('')) || arraysStringsEqual(ast.value, "!=".split('')) || arraysStringsEqual(ast.value, "<".split('')) || arraysStringsEqual(ast.value, "<=".split('')) || arraysStringsEqual(ast.value, ">".split('')) || arraysStringsEqual(ast.value, ">=".split('')) || arraysStringsEqual(ast.value, "->".split('')) || arraysStringsEqual(ast.value, "<->".split(''))){
      if( !ast.l.leaf ){
        BooleanASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1, endsWithIf);
        tl = assignedT.numberValue;
      }

      if( !ast.r.leaf ){
        BooleanASTToTFormFunctionsInner(ast.r, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1, endsWithIf);
        tr = assignedT.numberValue;
      }

      if( !ast.l.leaf ){
        FreeTVariable(ts, tl);
      }

      if( !ast.r.leaf ){
        FreeTVariable(ts, tr);
      }

      functionName = BooleanBinarySymbolToFunctionName(ast.value);

      tf.string = AppendString(tf.string, prefix);
      tf.string = AppendString(tf.string, functionName);
      tf.string = AppendString(tf.string, postfix);
      if(parenthesis){
        tf.string = AppendString(tf.string, "(".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }

      if(level > 0 || target.length == 0){
        t = AllocateTVariable(ts);
        assignedT.numberValue = t;
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(t);
        tf.string = AppendString(tf.string, numberString);
      }else{
        tf.string = AppendString(tf.string, target);
      }

      tf.string = AppendString(tf.string, ", ".split(''));

      if(ast.l.leaf){
        if(charIsNumber(ast.l.value[0])){
          value = [];
          value.length = 0;
          value = AppendString(value, prefix);
          if(wrappedNumber){
            value = AppendString(value, "Number".split(''));
            value = AppendString(value, postfix);
            value = AppendString(value, "(".split(''));
          }
          value = AppendString(value, ast.l.value);
          if(wrappedNumber){
            value = AppendString(value, ")".split(''));
          }
        }else{
          value = ast.l.value;
        }
        tf.string = AppendString(tf.string, value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tl);
        tf.string = AppendString(tf.string, numberString);
      }
      tf.string = AppendString(tf.string, ", ".split(''));
      if(ast.r.leaf){
        if(charIsNumber(ast.r.value[0])){
          value = [];
          value.length = 0;
          value = AppendString(value, prefix);
          if(wrappedNumber){
            value = AppendString(value, "Number".split(''));
            value = AppendString(value, postfix);
            value = AppendString(value, "(".split(''));
          }
          value = AppendString(value, ast.r.value);
          if(wrappedNumber){
            value = AppendString(value, ")".split(''));
          }
        }else{
          value = ast.r.value;
        }
        tf.string = AppendString(tf.string, value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tr);
        tf.string = AppendString(tf.string, numberString);
      }
      if(parenthesis){
        tf.string = AppendString(tf.string, ")".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }
      if(semicolon){
        tf.string = AppendString(tf.string, ";".split(''));
      }
      tf.string = AppendString(tf.string, "\n".split(''));
    }else if(arraysStringsEqual(ast.value, "()".split(''))){
      BooleanASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1, endsWithIf);
    }else if(arraysStringsEqual(ast.value, "!".split(''))){
      if( !ast.l.leaf ){
        BooleanASTToTFormFunctionsInner(ast.l, tf, ts, assignedT, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, level + 1, endsWithIf);
        tl = assignedT.numberValue;
        FreeTVariable(ts, tl);
      }

      functionName = BooleanBinarySymbolToFunctionName(ast.value);

      tf.string = AppendString(tf.string, prefix);
      tf.string = AppendString(tf.string, functionName);
      tf.string = AppendString(tf.string, postfix);
      if(parenthesis){
        tf.string = AppendString(tf.string, "(".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }

      if(level > 0 || target.length == 0){
        t = AllocateTVariable(ts);
        assignedT.numberValue = t;
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(t);
        tf.string = AppendString(tf.string, numberString);
      }else{
        tf.string = AppendString(tf.string, target);
      }

      tf.string = AppendString(tf.string, ", ".split(''));

      if(ast.l.leaf){
        tf.string = AppendString(tf.string, ast.l.value);
      }else{
        tf.string = AppendString(tf.string, "t".split(''));
        tf.string = AppendString(tf.string, tprefix);
        numberString = CreateStringDecimalFromNumber(tl);
        tf.string = AppendString(tf.string, numberString);
      }
      if(parenthesis){
        tf.string = AppendString(tf.string, ")".split(''));
      }else{
        tf.string = AppendString(tf.string, " ".split(''));
      }
      if(semicolon){
        tf.string = AppendString(tf.string, ";".split(''));
      }
      tf.string = AppendString(tf.string, "\n".split(''));
    }else{
      tf.string = AppendString(tf.string, "<failed>".split(''));
    }
  }else{
    tf.string = AppendString(tf.string, "<failed>".split(''));
  }

  if(level == 0 && endsWithIf){
    tf.string = AppendString(tf.string, "If ".split(''));
    if(target.length == 0){
      tf.string = AppendString(tf.string, "t".split(''));
      tf.string = AppendString(tf.string, tprefix);
      numberString = CreateStringDecimalFromNumber(t);
      tf.string = AppendString(tf.string, numberString);
    }else{
      tf.string = AppendString(tf.string, target);
    }
  }
}
function BooleanBinarySymbolToFunctionName(value){
  var f;

  f = "Unknown".split('');

  if(arraysStringsEqual(value, "!".split(''))){
    f = "Not".split('');
  }
  if(arraysStringsEqual(value, "&".split(''))){
    f = "And".split('');
  }
  if(arraysStringsEqual(value, "|".split(''))){
    f = "Or".split('');
  }
  if(arraysStringsEqual(value, "^".split(''))){
    f = "Xor".split('');
  }
  if(arraysStringsEqual(value, "=".split(''))){
    f = "Equal".split('');
  }
  if(arraysStringsEqual(value, "!=".split(''))){
    f = "Unequal".split('');
  }
  if(arraysStringsEqual(value, "<".split(''))){
    f = "LessThan".split('');
  }
  if(arraysStringsEqual(value, "<=".split(''))){
    f = "LessThanOrEqual".split('');
  }
  if(arraysStringsEqual(value, ">".split(''))){
    f = "MoreThan".split('');
  }
  if(arraysStringsEqual(value, ">=".split(''))){
    f = "MoreThanOrEqual".split('');
  }
  if(arraysStringsEqual(value, "->".split(''))){
    f = "Implies".split('');
  }
  if(arraysStringsEqual(value, "<->".split(''))){
    f = "Iff".split('');
  }

  return f;
}
function BooleanFormulaToTFormFunctions(f, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, endsWithIf, tf, message){
  var tokens;
  var success;
  var ast;
  var pos;

  tokens = {};
  success = TokenizeBooleanFormula(f, tokens, message);

  if(success){
    /* Parse */
    ast = {};
    pos = CreateNumberReference(0);
    success = ParseBooleanTokens(tokens, pos, ast, message);

    if(success){
      BooleanASTToTFormFunctions(ast, tf, prefix, postfix, tprefix, parenthesis, semicolon, wrappedNumber, target, endsWithIf);
    }
  }

  return success;
}
function testFormulaTranslationBoolean(failures){
  var f, af;
  var tokens;
  var success;
  var message, tf;
  var ast;
  var pos, t;

  f = "P | Q & !R -> S".split('');

  tokens = {};
  message = {};
  success = TokenizeBooleanFormula(f, tokens, message);

  AssertTrue(success, failures);
  AssertEquals(tokens.stringArray.length, 9, failures);
  AssertStringEquals(tokens.stringArray[0].string, "P".split(''), failures);
  AssertStringEquals(tokens.stringArray[1].string, "|".split(''), failures);
  AssertStringEquals(tokens.stringArray[6].string, "->".split(''), failures);

  /* Parse */
  ast = {};
  pos = CreateNumberReference(0);
  success = ParseBooleanTokens(tokens, pos, ast, message);
  AssertTrue(success, failures);

  if(success){
    af = ASTToBooleanFormula(ast);
    AssertStringEquals(f, af, failures);

    tf = CreateStringReference("".split(''));
    t = CreateNumberReference(0);
    BooleanASTToTForm(ast, tf, t);
    /*System.out.println(new String(tf.string)); */
    BooleanFormulaToTForm(f);

    success = BooleanFormulaToTFormFunctions(f, "".split(''), "".split(''), "b1".split(''), false, false, false, "".split(''), true, tf, message);
  }
}
function test(){
  var failures;

  failures = CreateNumberReference(0);

  testFormulaTranslationArithmetic(failures);
  testFormulaTranslationArithmetic2(failures);
  testFormulaTranslationBitwise(failures);
  testFormulaTranslationBoolean(failures);

  return failures.numberValue;
}
function testFormulaTranslationArithmetic(failures){
  var f, af;
  var tokens;
  var success;
  var message, tf;
  var ast;
  var pos, t;

  f = "(-b + sqrt(b^2 - 4*a*c))/(2*a)".split('');

  tokens = {};
  message = {};
  success = TokenizeArithmeticFormula(f, tokens, message);

  AssertTrue(success, failures);
  AssertEquals(tokens.stringArray.length, 24, failures);
  AssertStringEquals(tokens.stringArray[0].string, "(".split(''), failures);
  AssertStringEquals(tokens.stringArray[1].string, "-".split(''), failures);
  AssertStringEquals(tokens.stringArray[4].string, "sqrt".split(''), failures);

  /* Parse */
  ast = {};
  pos = CreateNumberReference(0);
  success = ParseArithmeticTokens(tokens, pos, ast, message);
  AssertTrue(success, failures);

  if(success){
    af = ASTToArithmeticFormula(ast);
    AssertStringEquals(f, af, failures);

    tf = CreateStringReference("".split(''));
    t = CreateNumberReference(0);
    ArithmeticASTToTForm(ast, tf, t);

    ArithmeticFormulaToTForm(f);

    success = ArithmeticFormulaToTFormFunctions(f, "".split(''), "".split(''), "u16".split(''), false, false, false, "x".split(''), tf, message);
  }
}
function testFormulaTranslationArithmetic2(failures){
  var f, af;
  var tokens;
  var success;
  var message, tf;
  var ast;
  var pos, t;

  f = "gross*14%".split('');

  tokens = {};
  message = {};
  success = TokenizeArithmeticFormula(f, tokens, message);

  AssertTrue(success, failures);
  AssertEquals(tokens.stringArray.length, 5, failures);
  AssertStringEquals(tokens.stringArray[0].string, "gross".split(''), failures);
  AssertStringEquals(tokens.stringArray[1].string, "*".split(''), failures);
  AssertStringEquals(tokens.stringArray[2].string, "14".split(''), failures);
  AssertStringEquals(tokens.stringArray[3].string, "%".split(''), failures);

  /* Parse */
  ast = {};
  pos = CreateNumberReference(0);
  success = ParseArithmeticTokens(tokens, pos, ast, message);
  AssertTrue(success, failures);

  if(success){
    af = ASTToArithmeticFormula(ast);
    AssertStringEquals(f, af, failures);

    tf = CreateStringReference("".split(''));
    t = CreateNumberReference(0);
    ArithmeticASTToTForm(ast, tf, t);
    /*System.out.println(new String(tf.string)); */
    ArithmeticFormulaToTForm(f);

    ArithmeticFormulaToTFormFunctions(f, "".split(''), "S8".split(''), "s8".split(''), false, false, false, "x".split(''), tf, message);
  }
}
function testFormulaTranslationBitwise(failures){
  var f, af;
  var tokens;
  var success;
  var message, tf;
  var ast;
  var pos, t;

  f = "d1 | d2 << 8 | d3 << 16".split('');

  tokens = {};
  message = {};
  success = TokenizeBitwiseFormula(f, tokens, message);

  AssertTrue(success, failures);
  AssertEquals(tokens.stringArray.length, 10, failures);
  AssertStringEquals(tokens.stringArray[0].string, "d1".split(''), failures);
  AssertStringEquals(tokens.stringArray[1].string, "|".split(''), failures);
  AssertStringEquals(tokens.stringArray[3].string, "<<".split(''), failures);

  /* Parse */
  ast = {};
  pos = CreateNumberReference(0);
  success = ParseBitwiseTokens(tokens, pos, ast, message);
  AssertTrue(success, failures);

  if(success){
    af = ASTToBitwiseFormula(ast);
    AssertStringEquals(f, af, failures);

    tf = CreateStringReference("".split(''));
    t = CreateNumberReference(0);
    BitwiseASTToTForm(ast, tf, t);
    /*System.out.println(new String(tf.string)); */
    BitwiseFormulaToTForm(f);

    success = BitwiseFormulaToTFormFunctions(f, "".split(''), "u8".split(''), "u8".split(''), false, false, false, "x".split(''), tf, message);
  }
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function CreateStringScientificNotationDecimalFromNumber(n){
  var mantissaReference, exponentReference;
  var e;
  var isPositive;
  var result;

  mantissaReference = {};
  exponentReference = {};
  result = [];
  result.length = 0;

  if(n < 0){
    isPositive = false;
    n =  -n;
  }else{
    isPositive = true;
  }

  if(n == 0){
    e = 0;
  }else{
    e = GetFirstDecimalDigitPosition(n);

    if(e < 0){
      n = n*Math.pow(10, Math.abs(e));
    }else{
      n = n/Math.pow(10, e);
    }
  }

  mantissaReference.string = CreateStringDecimalFromNumber(n);
  exponentReference.string = CreateStringDecimalFromNumber(e);

  if( !isPositive ){
    result = AppendString(result, "-".split(''));
  }

  result = AppendString(result, mantissaReference.string);
  result = AppendString(result, "e".split(''));
  result = AppendString(result, exponentReference.string);

  return result;
}
function CreateStringDecimalFromNumber(number){
  var string;
  var maximumDigits, i, d, digitPosition, trailingZeros;
  var hasPrintedPoint, isPositive, done;
  var characterReference;
  var c;
  var str;

  string = CreateDynamicArrayCharacters();
  isPositive = true;

  if(number < 0){
    isPositive = false;
    number =  -number;
  }

  if(number == 0){
    DynamicArrayAddCharacter(string, '0');
  }else{
    characterReference = {};

    maximumDigits = GetMaximumDigitsForDecimal();

    digitPosition = GetFirstDecimalDigitPosition(number);

    hasPrintedPoint = false;

    if( !isPositive ){
      DynamicArrayAddCharacter(string, '-');
    }

    /* Print leading zeros. */
    if(digitPosition < 0){
      DynamicArrayAddCharacter(string, '0');
      DynamicArrayAddCharacter(string, '.');
      hasPrintedPoint = true;
      for(i = 0; i <  -digitPosition - 1; i = i + 1){
        DynamicArrayAddCharacter(string, '0');
      }
    }

    /* Count trailing zeros */
    trailingZeros = 0;
    done = false;
    for(i = 0; i < maximumDigits &&  !done ; i = i + 1){
      d = GetDecimalDigitWithFirstDigitPosition(number, digitPosition, maximumDigits - i - 1);
      if(d == 0){
        trailingZeros = trailingZeros + 1;
      }else{
        done = true;
      }
    }

    /* Print number. */
    for(i = 0; i < maximumDigits; i = i + 1){
      d = GetDecimalDigitWithFirstDigitPosition(number, digitPosition, i);

      if( !hasPrintedPoint  && digitPosition - i + 1 == 0){
        if(maximumDigits - i > trailingZeros){
          DynamicArrayAddCharacter(string, '.');
        }
        hasPrintedPoint = true;
      }

      if(maximumDigits - i <= trailingZeros && hasPrintedPoint){
      }else{
        GetDecimalDigitCharacterFromNumberWithCheck(d, characterReference);
        c = characterReference.characterValue;
        DynamicArrayAddCharacter(string, c);
      }
    }

    /* Print trailing zeros. */
    for(i = 0; i < digitPosition - maximumDigits + 1; i = i + 1){
      DynamicArrayAddCharacter(string, '0');
    }
  }

  /* Done */
  str = DynamicArrayCharactersToArray(string);
  FreeDynamicArrayCharacters(string);
  return str;
}
function CreateStringFromNumberWithCheck(number, base, stringRef){
  var string;
  var maximumDigits, i, d, digitPosition, trailingZeros;
  var success, hasPrintedPoint, isPositive, done;
  var characterReference;
  var c;

  string = CreateDynamicArrayCharacters();
  isPositive = true;

  if(number < 0){
    isPositive = false;
    number =  -number;
  }

  if(number == 0){
    DynamicArrayAddCharacter(string, '0');
    success = true;
  }else{
    characterReference = {};

    if(m18IsInteger(base)){
      success = true;

      maximumDigits = GetMaximumDigitsForBase(base);

      digitPosition = GetFirstDigitPosition(number, base);

      hasPrintedPoint = false;

      if( !isPositive ){
        DynamicArrayAddCharacter(string, '-');
      }

      /* Print leading zeros. */
      if(digitPosition < 0){
        DynamicArrayAddCharacter(string, '0');
        DynamicArrayAddCharacter(string, '.');
        hasPrintedPoint = true;
        for(i = 0; i <  -digitPosition - 1; i = i + 1){
          DynamicArrayAddCharacter(string, '0');
        }
      }

      /* Count trailing zeros */
      trailingZeros = 0;
      done = false;
      for(i = 0; i < maximumDigits &&  !done ; i = i + 1){
        d = GetDigit(number, base, maximumDigits - i - 1);
        if(d == 0){
          trailingZeros = trailingZeros + 1;
        }else{
          done = true;
        }
      }

      /* Print number. */
      for(i = 0; i < maximumDigits && success; i = i + 1){
        d = GetDigit(number, base, i);

        if(d >= base){
          d = base - 1;
        }

        if( !hasPrintedPoint  && digitPosition - i + 1 == 0){
          if(maximumDigits - i > trailingZeros){
            DynamicArrayAddCharacter(string, '.');
          }
          hasPrintedPoint = true;
        }

        if(maximumDigits - i <= trailingZeros && hasPrintedPoint){
        }else{
          success = GetSingleDigitCharacterFromNumberWithCheck(d, base, characterReference);
          if(success){
            c = characterReference.characterValue;
            DynamicArrayAddCharacter(string, c);
          }
        }
      }

      if(success){
        /* Print trailing zeros. */
        for(i = 0; i < digitPosition - maximumDigits + 1; i = i + 1){
          DynamicArrayAddCharacter(string, '0');
        }
      }
    }else{
      success = false;
    }
  }

  if(success){
    stringRef.string = DynamicArrayCharactersToArray(string);
    FreeDynamicArrayCharacters(string);
  }

  /* Done */
  return success;
}
function GetMaximumDigitsForBase(base){
  var t;

  t = Math.pow(10, 15);
  return Math.floor(Math.log10(t)/Math.log10(base));
}
function GetMaximumDigitsForDecimal(){
  return 15;
}
function GetFirstDecimalDigitPosition(n){
  var power, m, i;
  var multiply, done;

  n = Math.abs(n);

  if(n != 0){
    if(Math.floor(n) < Math.pow(10, 15)){
      multiply = true;
    }else{
      multiply = false;
    }

    done = false;
    m = 0;
    for(i = 0;  !done ; i = i + 1){
      if(multiply){
        m = n*Math.pow(10, i);
        if(Math.floor(m) >= Math.pow(10, 14)){
          done = true;
        }
      }else{
        m = n/Math.pow(10, i);
        if(Math.floor(m) < Math.pow(10, 15)){
          done = true;
        }
      }
    }

    if(multiply){
      power = 15 - i;
    }else{
      power = 15 + i - 2;
    }

    if(m18Round(m) >= Math.pow(10, 15)){
      power = power + 1;
    }
  }else{
    power = 1;
  }

  return power;
}
function GetFirstDigitPosition(n, base){
  var power, m, i, maximumDigits;
  var multiply, done;

  maximumDigits = GetMaximumDigitsForBase(base);
  n = Math.abs(n);

  if(n != 0){
    if(Math.floor(n) < Math.pow(base, maximumDigits)){
      multiply = true;
    }else{
      multiply = false;
    }

    done = false;
    m = 0;
    for(i = 0;  !done ; i = i + 1){
      if(multiply){
        m = n*Math.pow(base, i);
        if(Math.floor(m) >= Math.pow(base, maximumDigits - 1)){
          done = true;
        }
      }else{
        m = n/Math.pow(base, i);
        if(Math.floor(m) < Math.pow(base, maximumDigits)){
          done = true;
        }
      }
    }

    if(multiply){
      power = maximumDigits - i;
    }else{
      power = maximumDigits + i - 2;
    }

    if(m18Round(m) >= Math.pow(base, maximumDigits)){
      power = power + 1;
    }
  }else{
    power = 1;
  }

  return power;
}
function GetSingleDigitCharacterFromNumberWithCheck(c, base, characterReference){
  var numberTable;
  var success;

  numberTable = GetDigitCharacterTable();

  if(c < base || c < numberTable.length){
    success = true;
    characterReference.characterValue = numberTable[c];
  }else{
    success = false;
  }

  return success;
}
function GetDecimalDigitCharacterFromNumberWithCheck(c, characterRef){
  var numberTable;
  var success;

  numberTable = "0123456789".split('');

  if(c >= 0 && c < 10){
    success = true;
    characterRef.characterValue = numberTable[c];
  }else{
    success = false;
  }

  return success;
}
function GetDigitCharacterTable(){
  var numberTable;

  numberTable = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ".split('');

  return numberTable;
}
function GetDecimalDigit(n, index){
  var digitPosition;

  digitPosition = GetFirstDecimalDigitPosition(n);

  return GetDecimalDigitWithFirstDigitPosition(n, digitPosition, index);
}
function GetDecimalDigitWithFirstDigitPosition(n, digitPosition, index){
  var d, e, m, i;

  n = Math.abs(n);

  e = 15 - digitPosition - 1;
  if(e < 0){
    n = Math.round(n/Math.pow(10, Math.abs(e)));
  }else{
    n = Math.round(n*Math.pow(10, e));
  }

  m = n;
  d = 0;
  for(i = 0; i < 15 - index; i = i + 1){
    d = Math.round(m%10);
    m = m - d;
    m = Math.round(m/10);
  }

  return d;
}
function GetDigit(n, base, index){
  var d, digitPosition, e, m, maximumDigits, i;

  n = Math.abs(n);
  maximumDigits = GetMaximumDigitsForBase(base);
  digitPosition = GetFirstDigitPosition(n, base);

  e = maximumDigits - digitPosition - 1;
  if(e < 0){
    n = Math.round(n/Math.pow(base, Math.abs(e)));
  }else{
    n = Math.round(n*Math.pow(base, e));
  }

  m = n;
  d = 0;
  for(i = 0; i < maximumDigits - index; i = i + 1){
    d = Math.round(m%base);
    m = m - d;
    m = Math.round(m/base);
  }

  return d;
}
function CreateNumberFromDecimalStringWithCheck(string, decimalReference, message){
  return CreateNumberFromStringWithCheck(string, 10, decimalReference, message);
}
function CreateNumberFromDecimalString(string){
  var doubleReference;
  var stringReference;
  var number;

  doubleReference = CreateNumberReference(0);
  stringReference = CreateStringReference("".split(''));
  CreateNumberFromStringWithCheck(string, 10, doubleReference, stringReference);
  number = doubleReference.numberValue;

  delete(doubleReference);
  delete(stringReference);

  return number;
}
function CreateNumberFromStringWithCheck(string, base, numberReference, message){
  var success;
  var numberIsPositive, exponentIsPositive;
  var beforePoint, afterPoint, exponent;

  numberIsPositive = CreateBooleanReference(true);
  exponentIsPositive = CreateBooleanReference(true);
  beforePoint = {};
  afterPoint = {};
  exponent = {};

  if(base >= 2 && base <= 36){
    success = ExtractPartsFromNumberString(string, base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent, message);

    if(success){
      numberReference.numberValue = CreateNumberFromParts(base, numberIsPositive.booleanValue, beforePoint.numberArray, afterPoint.numberArray, exponentIsPositive.booleanValue, exponent.numberArray);
    }
  }else{
    success = false;
    message.string = "Base must be from 2 to 36.".split('');
  }

  return success;
}
function CreateNumberFromParts(base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent){
  var n, i, p, e;

  n = 0;

  for(i = 0; i < beforePoint.length; i = i + 1){
    p = beforePoint[beforePoint.length - i - 1];

    n = n + p*Math.pow(base, i);
  }

  for(i = 0; i < afterPoint.length; i = i + 1){
    p = afterPoint[i];

    n = n + p/Math.pow(base, i + 1);
  }

  if(exponent.length > 0){
    e = 0;
    for(i = 0; i < exponent.length; i = i + 1){
      p = exponent[exponent.length - i - 1];

      e = e + p*Math.pow(base, i);
    }

    if( !exponentIsPositive ){
      e =  -e;
    }

    n = n*Math.pow(base, e);
  }

  if( !numberIsPositive ){
    n =  -n;
  }

  return n;
}
function ExtractPartsFromNumberString(n, base, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessages){
  var i, j, count;
  var success, done, complete;

  i = 0;
  complete = false;

  if(i < n.length){
    if(n[i] == '-'){
      numberIsPositive.booleanValue = false;
      i = i + 1;
    }else if(n[i] == '+'){
      numberIsPositive.booleanValue = true;
      i = i + 1;
    }

    success = true;
  }else{
    success = false;
    errorMessages.string = "Number cannot have length zero.".split('');
  }

  if(success){
    done = false;
    count = 0;
    for(; i + count < n.length &&  !done ; ){
      if(CharacterIsNumberCharacterInBase(n[i + count], base)){
        count = count + 1;
      }else{
        done = true;
      }
    }

    if(count >= 1){
      beforePoint.numberArray = [];
      beforePoint.numberArray.length = count;

      for(j = 0; j < count; j = j + 1){
        beforePoint.numberArray[j] = GetNumberFromNumberCharacterForBase(n[i + j], base);
      }

      i = i + count;

      if(i < n.length){
        success = true;
      }else{
        afterPoint.numberArray = [];
        afterPoint.numberArray.length = 0;
        exponent.numberArray = [];
        exponent.numberArray.length = 0;
        success = true;
        complete = true;
      }
    }else{
      success = false;
      errorMessages.string = "Number must have at least one number after the optional sign.".split('');
    }
  }

  if(success &&  !complete ){
    if(n[i] == '.'){
      i = i + 1;

      if(i < n.length){
        done = false;
        count = 0;
        for(; i + count < n.length &&  !done ; ){
          if(CharacterIsNumberCharacterInBase(n[i + count], base)){
            count = count + 1;
          }else{
            done = true;
          }
        }

        if(count >= 1){
          afterPoint.numberArray = [];
          afterPoint.numberArray.length = count;

          for(j = 0; j < count; j = j + 1){
            afterPoint.numberArray[j] = GetNumberFromNumberCharacterForBase(n[i + j], base);
          }

          i = i + count;

          if(i < n.length){
            success = true;
          }else{
            exponent.numberArray = [];
            exponent.numberArray.length = 0;
            success = true;
            complete = true;
          }
        }else{
          success = false;
          errorMessages.string = "There must be at least one digit after the decimal point.".split('');
        }
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the decimal point.".split('');
      }
    }else if(base <= 14 && (n[i] == 'e' || n[i] == 'E')){
      if(i < n.length){
        success = true;
        afterPoint.numberArray = [];
        afterPoint.numberArray.length = 0;
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the exponent.".split('');
      }
    }else{
      success = false;
      errorMessages.string = "Expected decimal point or exponent symbol.".split('');
    }
  }

  if(success &&  !complete ){
    if(base <= 14 && (n[i] == 'e' || n[i] == 'E')){
      i = i + 1;

      if(i < n.length){
        if(n[i] == '-'){
          exponentIsPositive.booleanValue = false;
          i = i + 1;
        }else if(n[i] == '+'){
          exponentIsPositive.booleanValue = true;
          i = i + 1;
        }

        if(i < n.length){
          done = false;
          count = 0;
          for(; i + count < n.length &&  !done ; ){
            if(CharacterIsNumberCharacterInBase(n[i + count], base)){
              count = count + 1;
            }else{
              done = true;
            }
          }

          if(count >= 1){
            exponent.numberArray = [];
            exponent.numberArray.length = count;

            for(j = 0; j < count; j = j + 1){
              exponent.numberArray[j] = GetNumberFromNumberCharacterForBase(n[i + j], base);
            }

            i = i + count;

            if(i == n.length){
              success = true;
            }else{
              success = false;
              errorMessages.string = "There cannot be any characters past the exponent of the number.".split('');
            }
          }else{
            success = false;
            errorMessages.string = "There must be at least one digit after the decimal point.".split('');
          }
        }else{
          success = false;
          errorMessages.string = "There must be at least one digit after the exponent symbol.".split('');
        }
      }else{
        success = false;
        errorMessages.string = "There must be at least one digit after the exponent symbol.".split('');
      }
    }else{
      success = false;
      errorMessages.string = "Expected exponent symbol.".split('');
    }
  }

  return success;
}
function GetNumberFromNumberCharacterForBase(c, base){
  var numberTable;
  var i;
  var position;

  numberTable = GetDigitCharacterTable();
  position = 0;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      position = i;
    }
  }

  return position;
}
function CharacterIsNumberCharacterInBase(c, base){
  var numberTable;
  var i;
  var found;

  numberTable = GetDigitCharacterTable();
  found = false;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      found = true;
    }
  }

  return found;
}
function StringToNumberArray(str){
  var numberArrayReference;
  var stringReference;
  var numbers;

  numberArrayReference = {};
  stringReference = {};

  StringToNumberArrayWithCheck(str, numberArrayReference, stringReference);

  numbers = numberArrayReference.numberArray;

  delete(numberArrayReference);
  delete(stringReference);

  return numbers;
}
function StringToNumberArrayWithCheck(str, numberArrayReference, errorMessage){
  var numberStrings;
  var numbers;
  var i;
  var numberString, trimmedNumberString;
  var success;
  var numberReference;

  numberStrings = SplitByString(str, ",".split(''));

  numbers = [];
  numbers.length = numberStrings.length;
  success = true;
  numberReference = {};

  for(i = 0; i < numberStrings.length; i = i + 1){
    numberString = numberStrings[i].string;
    trimmedNumberString = Trim(numberString);
    success = CreateNumberFromDecimalStringWithCheck(trimmedNumberString, numberReference, errorMessage);
    numbers[i] = numberReference.numberValue;

    FreeStringReference(numberStrings[i]);
    delete(trimmedNumberString);
  }

  delete(numberStrings);
  delete(numberReference);

  numberArrayReference.numberArray = numbers;

  return success;
}
function charToLowerCase(character){
  var toReturn;

  toReturn = character;
  if(character == 'A'){
    toReturn = 'a';
  }else if(character == 'B'){
    toReturn = 'b';
  }else if(character == 'C'){
    toReturn = 'c';
  }else if(character == 'D'){
    toReturn = 'd';
  }else if(character == 'E'){
    toReturn = 'e';
  }else if(character == 'F'){
    toReturn = 'f';
  }else if(character == 'G'){
    toReturn = 'g';
  }else if(character == 'H'){
    toReturn = 'h';
  }else if(character == 'I'){
    toReturn = 'i';
  }else if(character == 'J'){
    toReturn = 'j';
  }else if(character == 'K'){
    toReturn = 'k';
  }else if(character == 'L'){
    toReturn = 'l';
  }else if(character == 'M'){
    toReturn = 'm';
  }else if(character == 'N'){
    toReturn = 'n';
  }else if(character == 'O'){
    toReturn = 'o';
  }else if(character == 'P'){
    toReturn = 'p';
  }else if(character == 'Q'){
    toReturn = 'q';
  }else if(character == 'R'){
    toReturn = 'r';
  }else if(character == 'S'){
    toReturn = 's';
  }else if(character == 'T'){
    toReturn = 't';
  }else if(character == 'U'){
    toReturn = 'u';
  }else if(character == 'V'){
    toReturn = 'v';
  }else if(character == 'W'){
    toReturn = 'w';
  }else if(character == 'X'){
    toReturn = 'x';
  }else if(character == 'Y'){
    toReturn = 'y';
  }else if(character == 'Z'){
    toReturn = 'z';
  }

  return toReturn;
}
function charToUpperCase(character){
  var toReturn;

  toReturn = character;
  if(character == 'a'){
    toReturn = 'A';
  }else if(character == 'b'){
    toReturn = 'B';
  }else if(character == 'c'){
    toReturn = 'C';
  }else if(character == 'd'){
    toReturn = 'D';
  }else if(character == 'e'){
    toReturn = 'E';
  }else if(character == 'f'){
    toReturn = 'F';
  }else if(character == 'g'){
    toReturn = 'G';
  }else if(character == 'h'){
    toReturn = 'H';
  }else if(character == 'i'){
    toReturn = 'I';
  }else if(character == 'j'){
    toReturn = 'J';
  }else if(character == 'k'){
    toReturn = 'K';
  }else if(character == 'l'){
    toReturn = 'L';
  }else if(character == 'm'){
    toReturn = 'M';
  }else if(character == 'n'){
    toReturn = 'N';
  }else if(character == 'o'){
    toReturn = 'O';
  }else if(character == 'p'){
    toReturn = 'P';
  }else if(character == 'q'){
    toReturn = 'Q';
  }else if(character == 'r'){
    toReturn = 'R';
  }else if(character == 's'){
    toReturn = 'S';
  }else if(character == 't'){
    toReturn = 'T';
  }else if(character == 'u'){
    toReturn = 'U';
  }else if(character == 'v'){
    toReturn = 'V';
  }else if(character == 'w'){
    toReturn = 'W';
  }else if(character == 'x'){
    toReturn = 'X';
  }else if(character == 'y'){
    toReturn = 'Y';
  }else if(character == 'z'){
    toReturn = 'Z';
  }

  return toReturn;
}
function charIsUpperCase(character){
  var isUpper;

  isUpper = true;
  if(character == 'A'){
  }else if(character == 'B'){
  }else if(character == 'C'){
  }else if(character == 'D'){
  }else if(character == 'E'){
  }else if(character == 'F'){
  }else if(character == 'G'){
  }else if(character == 'H'){
  }else if(character == 'I'){
  }else if(character == 'J'){
  }else if(character == 'K'){
  }else if(character == 'L'){
  }else if(character == 'M'){
  }else if(character == 'N'){
  }else if(character == 'O'){
  }else if(character == 'P'){
  }else if(character == 'Q'){
  }else if(character == 'R'){
  }else if(character == 'S'){
  }else if(character == 'T'){
  }else if(character == 'U'){
  }else if(character == 'V'){
  }else if(character == 'W'){
  }else if(character == 'X'){
  }else if(character == 'Y'){
  }else if(character == 'Z'){
  }else{
    isUpper = false;
  }

  return isUpper;
}
function charIsLowerCase(character){
  var isLower;

  isLower = true;
  if(character == 'a'){
  }else if(character == 'b'){
  }else if(character == 'c'){
  }else if(character == 'd'){
  }else if(character == 'e'){
  }else if(character == 'f'){
  }else if(character == 'g'){
  }else if(character == 'h'){
  }else if(character == 'i'){
  }else if(character == 'j'){
  }else if(character == 'k'){
  }else if(character == 'l'){
  }else if(character == 'm'){
  }else if(character == 'n'){
  }else if(character == 'o'){
  }else if(character == 'p'){
  }else if(character == 'q'){
  }else if(character == 'r'){
  }else if(character == 's'){
  }else if(character == 't'){
  }else if(character == 'u'){
  }else if(character == 'v'){
  }else if(character == 'w'){
  }else if(character == 'x'){
  }else if(character == 'y'){
  }else if(character == 'z'){
  }else{
    isLower = false;
  }

  return isLower;
}
function charIsLetter(character){
  return charIsUpperCase(character) || charIsLowerCase(character);
}
function charIsNumber(character){
  var isNumberx;

  isNumberx = true;
  if(character == '0'){
  }else if(character == '1'){
  }else if(character == '2'){
  }else if(character == '3'){
  }else if(character == '4'){
  }else if(character == '5'){
  }else if(character == '6'){
  }else if(character == '7'){
  }else if(character == '8'){
  }else if(character == '9'){
  }else{
    isNumberx = false;
  }

  return isNumberx;
}
function charIsWhiteSpace(character){
  var isWhiteSpacex;

  isWhiteSpacex = true;
  if(character == ' '){
  }else if(character == '\t'){
  }else if(character == '\n'){
  }else if(character == '\r'){
  }else{
    isWhiteSpacex = false;
  }

  return isWhiteSpacex;
}
function charIsSymbol(character){
  var isSymbolx;

  isSymbolx = true;
  if(character == '!'){
  }else if(character == '\"'){
  }else if(character == '#'){
  }else if(character == '$'){
  }else if(character == '%'){
  }else if(character == '&'){
  }else if(character == '\''){
  }else if(character == '('){
  }else if(character == ')'){
  }else if(character == '*'){
  }else if(character == '+'){
  }else if(character == ','){
  }else if(character == '-'){
  }else if(character == '.'){
  }else if(character == '/'){
  }else if(character == ':'){
  }else if(character == ';'){
  }else if(character == '<'){
  }else if(character == '='){
  }else if(character == '>'){
  }else if(character == '?'){
  }else if(character == '@'){
  }else if(character == '['){
  }else if(character == '\\'){
  }else if(character == ']'){
  }else if(character == '^'){
  }else if(character == '_'){
  }else if(character == '`'){
  }else if(character == '{'){
  }else if(character == '|'){
  }else if(character == '}'){
  }else if(character == '~'){
  }else{
    isSymbolx = false;
  }

  return isSymbolx;
}
function charCharacterIsBefore(a, b){
  var ad, bd;

  ad = a.charCodeAt(0);
  bd = b.charCodeAt(0);

  return ad < bd;
}
function charDecimalDigitToCharacter(digit){
  var c;
  if(digit == 1){
    c = '1';
  }else if(digit == 2){
    c = '2';
  }else if(digit == 3){
    c = '3';
  }else if(digit == 4){
    c = '4';
  }else if(digit == 5){
    c = '5';
  }else if(digit == 6){
    c = '6';
  }else if(digit == 7){
    c = '7';
  }else if(digit == 8){
    c = '8';
  }else if(digit == 9){
    c = '9';
  }else{
    c = '0';
  }
  return c;
}
function charCharacterToDecimalDigit(c){
  var digit;

  if(c == '1'){
    digit = 1;
  }else if(c == '2'){
    digit = 2;
  }else if(c == '3'){
    digit = 3;
  }else if(c == '4'){
    digit = 4;
  }else if(c == '5'){
    digit = 5;
  }else if(c == '6'){
    digit = 6;
  }else if(c == '7'){
    digit = 7;
  }else if(c == '8'){
    digit = 8;
  }else if(c == '9'){
    digit = 9;
  }else{
    digit = 0;
  }

  return digit;
}
function arraysStringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function arraysNumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function arraysNumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function arraysBooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function arraysStringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function arraysFillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function arraysFillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function arraysFillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function arraysFillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysFillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysFillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysCopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function arraysCopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function arraysCopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function arraysCopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysCopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysCopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function arraysIsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function arraysCreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  arraysFillNumberArray(array, value);

  return array;
}
function arraysCreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  arraysFillBooleanArray(array, value);

  return array;
}
function arraysCreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  arraysFillString(array, value);

  return array;
}
function arraysSwapElementsOfNumberArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}
function arraysSwapElementsOfStringArray(A, ai, bi){
  var tmp;

  tmp = A.stringArray[ai];
  A.stringArray[ai] = A.stringArray[bi];
  A.stringArray[bi] = tmp;
}
function arraysReverseNumberArray(array){
  var i;

  for(i = 0; i < array.length/2; i = i + 1){
    arraysSwapElementsOfNumberArray(array, i, array.length - i - 1);
  }
}
function WriteStringToStingStream(stream, index, src){
  var i;

  for(i = 0; i < src.length; i = i + 1){
    stream[index.numberValue + i] = src[i];
  }
  index.numberValue = index.numberValue + src.length;
}
function WriteCharacterToStingStream(stream, index, src){
  stream[index.numberValue] = src;
  index.numberValue = index.numberValue + 1;
}
function WriteBooleanToStingStream(stream, index, src){
  if(src){
    WriteStringToStingStream(stream, index, "true".split(''));
  }else{
    WriteStringToStingStream(stream, index, "false".split(''));
  }
}
function SubstringWithCheck(string, from, to, stringReference){
  var success;

  if(from >= 0 && from <= string.length && to >= 0 && to <= string.length && from <= to){
    stringReference.string = Substring(string, from, to);
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Substring(string, from, to){
  var n;
  var i, lengthx;

  lengthx = to - from;

  n = [];
  n.length = lengthx;

  for(i = from; i < to; i = i + 1){
    n[i - from] = string[i];
  }

  return n;
}
function AppendString(s1, s2){
  var newString;

  newString = ConcatenateString(s1, s2);

  delete(s1);

  return newString;
}
function ConcatenateString(s1, s2){
  var newString;
  var i;

  newString = [];
  newString.length = s1.length + s2.length;

  for(i = 0; i < s1.length; i = i + 1){
    newString[i] = s1[i];
  }

  for(i = 0; i < s2.length; i = i + 1){
    newString[s1.length + i] = s2[i];
  }

  return newString;
}
function AppendCharacter(string, c){
  var newString;

  newString = ConcatenateCharacter(string, c);

  delete(string);

  return newString;
}
function ConcatenateCharacter(string, c){
  var newString;
  var i;
  newString = [];
  newString.length = string.length + 1;

  for(i = 0; i < string.length; i = i + 1){
    newString[i] = string[i];
  }

  newString[string.length] = c;

  return newString;
}
function SplitByCharacter(toSplit, splitBy){
  var split;
  var stringToSplitBy;

  stringToSplitBy = [];
  stringToSplitBy.length = 1;
  stringToSplitBy[0] = splitBy;

  split = SplitByString(toSplit, stringToSplitBy);

  delete(stringToSplitBy);

  return split;
}
function IndexOfCharacter(string, character, indexReference){
  var i;
  var found;

  found = false;
  for(i = 0; i < string.length &&  !found ; i = i + 1){
    if(string[i] == character){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function SubstringEqualsWithCheck(string, from, substring, equalsReference){
  var success;

  if(from < string.length){
    success = true;
    equalsReference.booleanValue = SubstringEquals(string, from, substring);
  }else{
    success = false;
  }

  return success;
}
function SubstringEquals(string, from, substring){
  var i;
  var equal;

  equal = true;
  if(string.length - from >= substring.length){
    for(i = 0; i < substring.length && equal; i = i + 1){
      if(string[from + i] != substring[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function IndexOfString(string, substring, indexReference){
  var i;
  var found;

  found = false;
  for(i = 0; i < string.length - substring.length + 1 &&  !found ; i = i + 1){
    if(SubstringEquals(string, i, substring)){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function ContainsCharacter(string, character){
  var i;
  var found;

  found = false;
  for(i = 0; i < string.length &&  !found ; i = i + 1){
    if(string[i] == character){
      found = true;
    }
  }

  return found;
}
function ContainsString(string, substring){
  return IndexOfString(string, substring, {});
}
function ToUpperCase(string){
  var i;

  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToUpperCase(string[i]);
  }
}
function ToLowerCase(string){
  var i;

  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToLowerCase(string[i]);
  }
}
function EqualsIgnoreCase(a, b){
  var equal;
  var i;

  if(a.length == b.length){
    equal = true;
    for(i = 0; i < a.length && equal; i = i + 1){
      if(charToLowerCase(a[i]) != charToLowerCase(b[i])){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function ReplaceString(string, toReplace, replaceWith){
  var result;
  var i, j;
  var equalsReference;
  var success;
  var da;

  da = CreateDynamicArrayCharacters();

  equalsReference = {};

  for(i = 0; i < string.length; ){
    success = SubstringEqualsWithCheck(string, i, toReplace, equalsReference);
    if(success){
      success = equalsReference.booleanValue;
    }

    if(success && toReplace.length > 0){
      for(j = 0; j < replaceWith.length; j = j + 1){
        DynamicArrayAddCharacter(da, replaceWith[j]);
      }
      i = i + toReplace.length;
    }else{
      DynamicArrayAddCharacter(da, string[i]);
      i = i + 1;
    }
  }

  result = DynamicArrayCharactersToArray(da);

  FreeDynamicArrayCharacters(da);

  return result;
}
function ReplaceCharacterToNew(string, toReplace, replaceWith){
  var result;
  var i;

  result = [];
  result.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    if(string[i] == toReplace){
      result[i] = replaceWith;
    }else{
      result[i] = string[i];
    }
  }

  return result;
}
function ReplaceCharacter(string, toReplace, replaceWith){
  var i;

  for(i = 0; i < string.length; i = i + 1){
    if(string[i] == toReplace){
      string[i] = replaceWith;
    }
  }
}
function Trim(string){
  var result;
  var i, lastWhitespaceLocationStart, lastWhitespaceLocationEnd;
  var firstNonWhitespaceFound;

  /* Find whitepaces at the start. */
  lastWhitespaceLocationStart =  -1;
  firstNonWhitespaceFound = false;
  for(i = 0; i < string.length &&  !firstNonWhitespaceFound ; i = i + 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationStart = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  /* Find whitepaces at the end. */
  lastWhitespaceLocationEnd = string.length;
  firstNonWhitespaceFound = false;
  for(i = string.length - 1; i >= 0 &&  !firstNonWhitespaceFound ; i = i - 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationEnd = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  if(lastWhitespaceLocationStart < lastWhitespaceLocationEnd){
    result = Substring(string, lastWhitespaceLocationStart + 1, lastWhitespaceLocationEnd);
  }else{
    result = [];
    result.length = 0;
  }

  return result;
}
function StartsWith(string, start){
  var startsWithString;

  startsWithString = false;
  if(string.length >= start.length){
    startsWithString = SubstringEquals(string, 0, start);
  }

  return startsWithString;
}
function EndsWith(string, end){
  var endsWithString;

  endsWithString = false;
  if(string.length >= end.length){
    endsWithString = SubstringEquals(string, string.length - end.length, end);
  }

  return endsWithString;
}
function SplitByString(toSplit, splitBy){
  var split;
  var next;
  var i;
  var c;
  var n;

  split = [];
  split.length = 0;

  next = [];
  next.length = 0;
  for(i = 0; i < toSplit.length; ){
    c = toSplit[i];

    if(SubstringEquals(toSplit, i, splitBy)){
      n = {};
      n.string = next;
      split = AddString(split, n);
      next = [];
      next.length = 0;
      i = i + splitBy.length;
    }else{
      next = AppendCharacter(next, c);
      i = i + 1;
    }
  }

  n = {};
  n.string = next;
  split = AddString(split, n);

  return split;
}
function StringIsBefore(a, b){
  var before, equal, done;
  var i;

  before = false;
  equal = true;
  done = false;

  if(a.length == 0 && b.length > 0){
    before = true;
  }else{
    for(i = 0; i < a.length && i < b.length &&  !done ; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
      if(charCharacterIsBefore(a[i], b[i])){
        before = true;
      }
      if(charCharacterIsBefore(b[i], a[i])){
        done = true;
      }
    }

    if(equal){
      if(a.length < b.length){
        before = true;
      }
    }
  }

  return before;
}
function JoinStringsWithSeparator(strings, separator){
  var result, string;
  var lengthx, i;
  var index;

  index = CreateNumberReference(0);

  lengthx = 0;
  for(i = 0; i < strings.length; i = i + 1){
    lengthx = lengthx + strings[i].string.length;
  }
  lengthx = lengthx + (strings.length - 1)*separator.length;

  result = [];
  result.length = lengthx;

  for(i = 0; i < strings.length; i = i + 1){
    string = strings[i].string;
    WriteStringToStingStream(result, index, string);
    if(i + 1 < strings.length){
      WriteStringToStingStream(result, index, separator);
    }
  }

  delete(index);

  return result;
}
function JoinStrings(strings){
  var result, string;
  var lengthx, i;
  var index;

  index = CreateNumberReference(0);

  lengthx = 0;
  for(i = 0; i < strings.length; i = i + 1){
    lengthx = lengthx + strings[i].string.length;
  }

  result = [];
  result.length = lengthx;

  for(i = 0; i < strings.length; i = i + 1){
    string = strings[i].string;
    WriteStringToStingStream(result, index, string);
  }

  delete(index);

  return result;
}
function AddNumber(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddNumberRef(list, i){
  list.numberArray = AddNumber(list.numberArray, i);
}
function RemoveNumber(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetNumberRef(list, i){
  return list.numberArray[i];
}
function RemoveNumberRef(list, i){
  list.numberArray = RemoveNumber(list.numberArray, i);
}
function AddString(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;

  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddStringRef(list, i){
  list.stringArray = AddString(list.stringArray, i);
}
function RemoveString(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetStringRef(list, i){
  return list.stringArray[i];
}
function RemoveStringRef(list, i){
  list.stringArray = RemoveString(list.stringArray, i);
}
function CreateDynamicArrayCharacters(){
  var da;

  da = {};
  da.array = [];
  da.array.length = 10;
  da.lengthx = 0;

  return da;
}
function CreateDynamicArrayCharactersWithInitialCapacity(capacity){
  var da;

  da = {};
  da.array = [];
  da.array.length = capacity;
  da.lengthx = 0;

  return da;
}
function DynamicArrayAddCharacter(da, value){
  if(da.lengthx == da.array.length){
    DynamicArrayCharactersIncreaseSize(da);
  }

  da.array[da.lengthx] = value;
  da.lengthx = da.lengthx + 1;
}
function DynamicArrayCharactersIncreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*3/2);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < da.array.length; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayCharactersDecreaseSizeNecessary(da){
  var needsDecrease;

  needsDecrease = false;

  if(da.lengthx > 10){
    needsDecrease = da.lengthx <= Math.round(da.array.length*2/3);
  }

  return needsDecrease;
}
function DynamicArrayCharactersDecreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*2/3);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < newLength; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayCharactersIndex(da, index){
  return da.array[index];
}
function DynamicArrayCharactersLength(da){
  return da.lengthx;
}
function DynamicArrayInsertCharacter(da, index, value){
  var i;

  if(da.lengthx == da.array.length){
    DynamicArrayCharactersIncreaseSize(da);
  }

  for(i = da.lengthx; i > index; i = i - 1){
    da.array[i] = da.array[i - 1];
  }

  da.array[index] = value;

  da.lengthx = da.lengthx + 1;
}
function DynamicArrayCharacterSet(da, index, value){
  var success;

  if(index < da.lengthx){
    da.array[index] = value;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DynamicArrayRemoveCharacter(da, index){
  var i;

  for(i = index; i < da.lengthx - 1; i = i + 1){
    da.array[i] = da.array[i + 1];
  }

  da.lengthx = da.lengthx - 1;

  if(DynamicArrayCharactersDecreaseSizeNecessary(da)){
    DynamicArrayCharactersDecreaseSize(da);
  }
}
function FreeDynamicArrayCharacters(da){
  delete(da.array);
  delete(da);
}
function DynamicArrayCharactersToArray(da){
  var array;
  var i;

  array = [];
  array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    array[i] = da.array[i];
  }

  return array;
}
function ArrayToDynamicArrayCharactersWithOptimalSize(array){
  var da;
  var i;
  var c, n, newCapacity;

  c = array.length;
  n = (Math.log(c) - 1)/Math.log(3/2);
  newCapacity = Math.floor(n) + 1;

  da = CreateDynamicArrayCharactersWithInitialCapacity(newCapacity);

  for(i = 0; i < array.length; i = i + 1){
    da.array[i] = array[i];
  }

  return da;
}
function ArrayToDynamicArrayCharacters(array){
  var da;

  da = {};
  da.array = arraysCopyString(array);
  da.lengthx = array.length;

  return da;
}
function DynamicArrayCharactersEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.lengthx == b.lengthx){
    for(i = 0; i < a.lengthx && equal; i = i + 1){
      if(a.array[i] != b.array[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function DynamicArrayCharactersToLinkedList(da){
  var ll;
  var i;

  ll = CreateLinkedListCharacter();

  for(i = 0; i < da.lengthx; i = i + 1){
    LinkedListAddCharacter(ll, da.array[i]);
  }

  return ll;
}
function LinkedListToDynamicArrayCharacters(ll){
  var da;
  var i;
  var node;

  node = ll.first;

  da = {};
  da.lengthx = LinkedListCharactersLength(ll);

  da.array = [];
  da.array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    da.array[i] = node.value;
    node = node.next;
  }

  return da;
}
function AddBoolean(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddBooleanRef(list, i){
  list.booleanArray = AddBoolean(list.booleanArray, i);
}
function RemoveBoolean(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetBooleanRef(list, i){
  return list.booleanArray[i];
}
function RemoveDecimalRef(list, i){
  list.booleanArray = RemoveBoolean(list.booleanArray, i);
}
function CreateLinkedListString(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddString(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListStringsToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListStringsLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = {};
    array[i].string = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListStringsLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListString(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function CreateLinkedListNumbers(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function CreateLinkedListNumbersArray(lengthx){
  var lls;
  var i;

  lls = [];
  lls.length = lengthx;
  for(i = 0; i < lls.length; i = i + 1){
    lls[i] = CreateLinkedListNumbers();
  }

  return lls;
}
function LinkedListAddNumber(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListNumbersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function LinkedListNumbersIndex(ll, index){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  return node.value;
}
function LinkedListInsertNumber(ll, index, value){
  var i;
  var node, tmp;

  if(index == 0){
    tmp = ll.first;
    ll.first = {};
    ll.first.next = tmp;
    ll.first.value = value;
    ll.first.end = false;
  }else{
    node = ll.first;
    for(i = 0; i < index - 1; i = i + 1){
      node = node.next;
    }

    tmp = node.next;
    node.next = {};
    node.next.next = tmp;
    node.next.value = value;
    node.next.end = false;
  }
}
function LinkedListSet(ll, index, value){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  node.next.value = value;
}
function LinkedListRemoveNumber(ll, index){
  var i;
  var node, prev;

  node = ll.first;
  prev = ll.first;

  for(i = 0; i < index; i = i + 1){
    prev = node;
    node = node.next;
  }

  if(index == 0){
    ll.first = prev.next;
  }
  if( !prev.next.end ){
    prev.next = prev.next.next;
  }
}
function FreeLinkedListNumbers(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function FreeLinkedListNumbersArray(lls){
  var i;

  for(i = 0; i < lls.length; i = i + 1){
    FreeLinkedListNumbers(lls[i]);
  }
  delete(lls);
}
function LinkedListNumbersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListNumbersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function ArrayToLinkedListNumbers(array){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < array.length; i = i + 1){
    LinkedListAddNumber(ll, array[i]);
  }

  return ll;
}
function LinkedListNumbersEqual(a, b){
  var equal, done;
  var an, bn;

  an = a.first;
  bn = b.first;

  equal = true;
  done = false;
  for(; equal &&  !done ; ){
    if(an.end == bn.end){
      if(an.end){
        done = true;
      }else if(an.value == bn.value){
        an = an.next;
        bn = bn.next;
      }else{
        equal = false;
      }
    }else{
      equal = false;
    }
  }

  return equal;
}
function CreateLinkedListCharacter(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddCharacter(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListCharactersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListCharactersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListCharactersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListCharacter(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function LinkedListCharactersAddString(ll, str){
  var i;

  for(i = 0; i < str.length; i = i + 1){
    LinkedListAddCharacter(ll, str[i]);
  }
}
function CreateDynamicArrayNumbers(){
  var da;

  da = {};
  da.array = [];
  da.array.length = 10;
  da.lengthx = 0;

  return da;
}
function CreateDynamicArrayNumbersWithInitialCapacity(capacity){
  var da;

  da = {};
  da.array = [];
  da.array.length = capacity;
  da.lengthx = 0;

  return da;
}
function DynamicArrayAddNumber(da, value){
  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  da.array[da.lengthx] = value;
  da.lengthx = da.lengthx + 1;
}
function DynamicArrayNumbersIncreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*3/2);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < da.array.length; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersDecreaseSizeNecessary(da){
  var needsDecrease;

  needsDecrease = false;

  if(da.lengthx > 10){
    needsDecrease = da.lengthx <= Math.round(da.array.length*2/3);
  }

  return needsDecrease;
}
function DynamicArrayNumbersDecreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*2/3);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < newLength; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersIndex(da, index){
  return da.array[index];
}
function DynamicArrayNumbersLength(da){
  return da.lengthx;
}
function DynamicArrayInsertNumber(da, index, value){
  var i;

  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  for(i = da.lengthx; i > index; i = i - 1){
    da.array[i] = da.array[i - 1];
  }

  da.array[index] = value;

  da.lengthx = da.lengthx + 1;
}
function DynamicArrayNumberSet(da, index, value){
  var success;

  if(index < da.lengthx){
    da.array[index] = value;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DynamicArrayRemoveNumber(da, index){
  var i;

  for(i = index; i < da.lengthx - 1; i = i + 1){
    da.array[i] = da.array[i + 1];
  }

  da.lengthx = da.lengthx - 1;

  if(DynamicArrayNumbersDecreaseSizeNecessary(da)){
    DynamicArrayNumbersDecreaseSize(da);
  }
}
function FreeDynamicArrayNumbers(da){
  delete(da.array);
  delete(da);
}
function DynamicArrayNumbersToArray(da){
  var array;
  var i;

  array = [];
  array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    array[i] = da.array[i];
  }

  return array;
}
function ArrayToDynamicArrayNumbersWithOptimalSize(array){
  var da;
  var i;
  var c, n, newCapacity;

  /*
         c = 10*(3/2)^n
         log(c) = log(10*(3/2)^n)
         log(c) = log(10) + log((3/2)^n)
         log(c) = 1 + log((3/2)^n)
         log(c) - 1 = log((3/2)^n)
         log(c) - 1 = n*log(3/2)
         n = (log(c) - 1)/log(3/2)
         */
  c = array.length;
  n = (Math.log(c) - 1)/Math.log(3/2);
  newCapacity = Math.floor(n) + 1;

  da = CreateDynamicArrayNumbersWithInitialCapacity(newCapacity);

  for(i = 0; i < array.length; i = i + 1){
    da.array[i] = array[i];
  }

  return da;
}
function ArrayToDynamicArrayNumbers(array){
  var da;

  da = {};
  da.array = arraysCopyNumberArray(array);
  da.lengthx = array.length;

  return da;
}
function DynamicArrayNumbersEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.lengthx == b.lengthx){
    for(i = 0; i < a.lengthx && equal; i = i + 1){
      if(a.array[i] != b.array[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function DynamicArrayNumbersToLinkedList(da){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < da.lengthx; i = i + 1){
    LinkedListAddNumber(ll, da.array[i]);
  }

  return ll;
}
function LinkedListToDynamicArrayNumbers(ll){
  var da;
  var i;
  var node;

  node = ll.first;

  da = {};
  da.lengthx = LinkedListNumbersLength(ll);

  da.array = [];
  da.array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    da.array[i] = node.value;
    node = node.next;
  }

  return da;
}
function DynamicArrayNumbersIndexOf(arr, n, foundReference){
  var found;
  var i;

  found = false;
  for(i = 0; i < arr.lengthx &&  !found ; i = i + 1){
    if(arr.array[i] == n){
      found = true;
    }
  }
  if( !found ){
    i =  -1;
  }else{
    i = i - 1;
  }

  foundReference.booleanValue = found;

  return i;
}
function DynamicArrayNumbersIsInArray(arr, n){
  var found;
  var i;

  found = false;
  for(i = 0; i < arr.lengthx &&  !found ; i = i + 1){
    if(arr.array[i] == n){
      found = true;
    }
  }

  return found;
}
function AddCharacter(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddCharacterRef(list, i){
  list.string = AddCharacter(list.string, i);
}
function RemoveCharacter(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }

  return newlist;
}
function GetCharacterRef(list, i){
  return list.string[i];
}
function RemoveCharacterRef(list, i){
  list.string = RemoveCharacter(list.string, i);
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !arraysStringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function m18Negate(x){
  return  -x;
}
function m18Positive(x){
  return  +x;
}
function m18Factorial(x){
  var i, f;

  f = 1;

  for(i = 2; i <= x; i = i + 1){
    f = f*i;
  }

  return f;
}
function m18Round(x){
  return Math.floor(x + 0.5);
}
function m18BankersRound(x){
  var r;

  if(m18Absolute(x - m18Truncate(x)) == 0.5){
    if( !m18DivisibleBy(m18Round(x), 2) ){
      r = m18Round(x) - 1;
    }else{
      r = m18Round(x);
    }
  }else{
    r = m18Round(x);
  }

  return r;
}
function m18Ceil(x){
  return Math.ceil(x);
}
function m18Floor(x){
  return Math.floor(x);
}
function m18Truncate(x){
  var t;

  if(x >= 0){
    t = Math.floor(x);
  }else{
    t = Math.ceil(x);
  }

  return t;
}
function m18Absolute(x){
  return Math.abs(x);
}
function m18Logarithm(x){
  return Math.log10(x);
}
function m18NaturalLogarithm(x){
  return Math.log(x);
}
function m18Sin(x){
  return Math.sin(x);
}
function m18Cos(x){
  return Math.cos(x);
}
function m18Tan(x){
  return Math.tan(x);
}
function m18Asin(x){
  return Math.asin(x);
}
function m18Acos(x){
  return Math.acos(x);
}
function m18Atan(x){
  return Math.atan(x);
}
function m18Atan2(y, x){
  var a;

  /* Atan2 is an invalid operation when x = 0 and y = 0, but this method does not return errors. */
  a = 0;

  if(x > 0){
    a = m18Atan(y/x);
  }else if(x < 0 && y >= 0){
    a = m18Atan(y/x) + Math.PI;
  }else if(x < 0 && y < 0){
    a = m18Atan(y/x) - Math.PI;
  }else if(x == 0 && y > 0){
    a = Math.PI/2;
  }else if(x == 0 && y < 0){
    a =  -Math.PI/2;
  }

  return a;
}
function m18Squareroot(x){
  return Math.sqrt(x);
}
function m18Exp(x){
  return Math.exp(x);
}
function m18DivisibleBy(a, b){
  return ((a%b) == 0);
}
function m18Combinations(n, k){
  var i, j, c;

  c = 1;
  j = 1;
  i = n - k + 1;

  for(; i <= n; ){
    c = c*i;
    c = c/j;

    i = i + 1;
    j = j + 1;
  }

  return c;
}
function m18Permutations(n, k){
  var i, c;

  c = 1;

  for(i = n - k + 1; i <= n; i = i + 1){
    c = c*i;
  }

  return c;
}
function m18EpsilonCompare(a, b, epsilon){
  return Math.abs(a - b) < epsilon;
}
function m18GreatestCommonDivisor(a, b){
  var t;

  for(; b != 0; ){
    t = b;
    b = a%b;
    a = t;
  }

  return a;
}
function m18GCDWithSubtraction(a, b){
  var g;

  if(a == 0){
    g = b;
  }else{
    for(; b != 0; ){
      if(a > b){
        a = a - b;
      }else{
        b = b - a;
      }
    }

    g = a;
  }

  return g;
}
function m18IsInteger(a){
  return (a - Math.floor(a)) == 0;
}
function m18GreatestCommonDivisorWithCheck(a, b, gcdReference){
  var success;
  var gcd;

  if(m18IsInteger(a) && m18IsInteger(b)){
    gcd = m18GreatestCommonDivisor(a, b);
    gcdReference.numberValue = gcd;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function m18LeastCommonMultiple(a, b){
  var lcm;

  if(a > 0 && b > 0){
    lcm = Math.abs(a*b)/m18GreatestCommonDivisor(a, b);
  }else{
    lcm = 0;
  }

  return lcm;
}
function m18Sign(a){
  var s;

  if(a > 0){
    s = 1;
  }else if(a < 0){
    s =  -1;
  }else{
    s = 0;
  }

  return s;
}
function m18Max(a, b){
  return Math.max(a, b);
}
function m18Min(a, b){
  return Math.min(a, b);
}
function m18Power(a, b){
  return Math.pow(a, b);
}
function m18Gamma(x){
  return m18LanczosApproximation(x);
}
function m18LogGamma(x){
  return Math.log(m18Gamma(x));
}
function m18LanczosApproximation(z){
  var p;
  var i, y, t, x;

  p = [];
  p.length = 8;
  p[0] = 676.5203681218851;
  p[1] =  -1259.1392167224028;
  p[2] = 771.32342877765313;
  p[3] =  -176.61502916214059;
  p[4] = 12.507343278686905;
  p[5] =  -0.13857109526572012;
  p[6] = 9.9843695780195716e-6;
  p[7] = 1.5056327351493116e-7;

  if(z < 0.5){
    y = Math.PI/(Math.sin(Math.PI*z)*m18LanczosApproximation(1 - z));
  }else{
    z = z - 1;
    x = 0.99999999999980993;
    for(i = 0; i < p.length; i = i + 1){
      x = x + p[i]/(z + i + 1);
    }
    t = z + p.length - 0.5;
    y = Math.sqrt(2*Math.PI)*Math.pow(t, z + 0.5)*Math.exp( -t)*x;
  }

  return y;
}
function m18Beta(x, y){
  return m18Gamma(x)*m18Gamma(y)/m18Gamma(x + y);
}
function m18Sinh(x){
  return (Math.exp(x) - Math.exp( -x))/2;
}
function m18Cosh(x){
  return (Math.exp(x) + Math.exp( -x))/2;
}
function m18Tanh(x){
  return m18Sinh(x)/m18Cosh(x);
}
function m18Cot(x){
  return 1/Math.tan(x);
}
function m18Sec(x){
  return 1/Math.cos(x);
}
function m18Csc(x){
  return 1/Math.sin(x);
}
function m18Coth(x){
  return m18Cosh(x)/m18Sinh(x);
}
function m18Sech(x){
  return 1/m18Cosh(x);
}
function m18Csch(x){
  return 1/m18Sinh(x);
}
function m18Error(x){
  var y, t, tau, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10;

  if(x == 0){
    y = 0;
  }else if(x < 0){
    y =  -m18Error( -x);
  }else{
    c1 =  -1.26551223;
    c2 =  +1.00002368;
    c3 =  +0.37409196;
    c4 =  +0.09678418;
    c5 =  -0.18628806;
    c6 =  +0.27886807;
    c7 =  -1.13520398;
    c8 =  +1.48851587;
    c9 =  -0.82215223;
    c10 =  +0.17087277;

    t = 1/(1 + 0.5*Math.abs(x));

    tau = t*Math.exp( -(Math.pow(x, 2)) + c1 + t*(c2 + t*(c3 + t*(c4 + t*(c5 + t*(c6 + t*(c7 + t*(c8 + t*(c9 + t*c10)))))))));

    y = 1 - tau;
  }

  return y;
}
function m18ErrorInverse(x){
  var y, a, t;

  a = (8*(Math.PI - 3))/(3*Math.PI*(4 - Math.PI));

  t = 2/(Math.PI*a) + Math.log(1 - Math.pow(x, 2))/2;
  y = m18Sign(x)*Math.sqrt(Math.sqrt(Math.pow(t, 2) - Math.log(1 - Math.pow(x, 2))/a) - t);

  return y;
}
function m18FallingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x - k);
  }

  return y;
}
function m18RisingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x + k);
  }

  return y;
}
function m18Hypergeometric(a, b, c, z, maxIterations, precision){
  var y;

  if(Math.abs(z) >= 0.5){
    y = Math.pow(1 - z,  -a)*m18HypergeometricDirect(a, c - b, c, z/(z - 1), maxIterations, precision);
  }else{
    y = m18HypergeometricDirect(a, b, c, z, maxIterations, precision);
  }

  return y;
}
function m18HypergeometricDirect(a, b, c, z, maxIterations, precision){
  var y, yp, n;
  var done;

  y = 0;
  done = false;

  for(n = 0; n < maxIterations &&  !done ; n = n + 1){
    yp = m18RisingFactorial(a, n)*m18RisingFactorial(b, n)/m18RisingFactorial(c, n)*Math.pow(z, n)/m18Factorial(n);
    if(Math.abs(yp) < precision){
      done = true;
    }
    y = y + yp;
  }

  return y;
}
function m18BernouilliNumber(n){
  return m18AkiyamaTanigawaAlgorithm(n);
}
function m18AkiyamaTanigawaAlgorithm(n){
  var m, j, B;
  var A;

  A = [];
  A.length = n + 1;

  for(m = 0; m <= n; m = m + 1){
    A[m] = 1/(m + 1);
    for(j = m; j >= 1; j = j - 1){
      A[j - 1] = j*(A[j - 1] - A[j]);
    }
  }

  B = A[0];

  delete(A);

  return B;
}


module.exports = {
	TokenizeBooleanFormula: TokenizeBooleanFormula,
	ParseBooleanTokens: ParseBooleanTokens,
	ParseIff: ParseIff,
	ParseImplies: ParseImplies,
	ParseLogicalOr: ParseLogicalOr,
	ParseLogicalAnd: ParseLogicalAnd,
	ParseLogicalXor: ParseLogicalXor,
	ParseLogicalComparison: ParseLogicalComparison,
	ParseLogicalLiteralVariableNotParenthesis: ParseLogicalLiteralVariableNotParenthesis,
	TokenizeArithmeticFormula: TokenizeArithmeticFormula,
	ParseArithmeticTokens: ParseArithmeticTokens,
	ParseAdditionOrSubtraction: ParseAdditionOrSubtraction,
	ParseMultiplicationOrDivision: ParseMultiplicationOrDivision,
	ParseExponentiation: ParseExponentiation,
	ParseLiteralVariableUnaryParenthesis: ParseLiteralVariableUnaryParenthesis,
	IsKnownArithmeticFunction: IsKnownArithmeticFunction,
	IsKnownMatrixFunction: IsKnownMatrixFunction,
	TokenizeBitwiseFormula: TokenizeBitwiseFormula,
	ParseBitwiseTokens: ParseBitwiseTokens,
	ParseOr: ParseOr,
	ParseXor: ParseXor,
	ParseAnd: ParseAnd,
	ParseShift: ParseShift,
	ParseLiteralVariableNotParenthesis: ParseLiteralVariableNotParenthesis,
	ASTToTFormFunctions: ASTToTFormFunctions,
	ASTToTFormFunctionsInner: ASTToTFormFunctionsInner,
	ArithmeticBinarySymbolToFunctionName: ArithmeticBinarySymbolToFunctionName,
	ArithmeticFormulaToTFormFunctions: ArithmeticFormulaToTFormFunctions,
	AllocateTVariable: AllocateTVariable,
	FreeTVariable: FreeTVariable,
	ASTToBooleanFormula: ASTToBooleanFormula,
	BooleanASTToTForm: BooleanASTToTForm,
	BooleanFormulaToTForm: BooleanFormulaToTForm,
	BitwiseASTToTFormFunctions: BitwiseASTToTFormFunctions,
	BitwiseASTToTFormFunctionsInner: BitwiseASTToTFormFunctionsInner,
	BitwiseBinarySymbolToFunctionName: BitwiseBinarySymbolToFunctionName,
	BitwiseFormulaToTFormFunctions: BitwiseFormulaToTFormFunctions,
	AddToNumberReference: AddToNumberReference,
	TokenIs: TokenIs,
	NextTokenIs: NextTokenIs,
	NextIndex: NextIndex,
	Index: Index,
	AssignASTNode: AssignASTNode,
	CreateASTNode: CreateASTNode,
	ASTToArithmeticFormula: ASTToArithmeticFormula,
	ArithmeticASTToTForm: ArithmeticASTToTForm,
	ArithmeticFormulaToTForm: ArithmeticFormulaToTForm,
	ASTToBitwiseFormula: ASTToBitwiseFormula,
	BitwiseASTToTForm: BitwiseASTToTForm,
	BitwiseFormulaToTForm: BitwiseFormulaToTForm,
	BooleanASTToTFormFunctions: BooleanASTToTFormFunctions,
	BooleanASTToTFormFunctionsInner: BooleanASTToTFormFunctionsInner,
	BooleanBinarySymbolToFunctionName: BooleanBinarySymbolToFunctionName,
	BooleanFormulaToTFormFunctions: BooleanFormulaToTFormFunctions,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	CreateStringScientificNotationDecimalFromNumber: CreateStringScientificNotationDecimalFromNumber,
	CreateStringDecimalFromNumber: CreateStringDecimalFromNumber,
	CreateStringFromNumberWithCheck: CreateStringFromNumberWithCheck,
	GetMaximumDigitsForBase: GetMaximumDigitsForBase,
	GetMaximumDigitsForDecimal: GetMaximumDigitsForDecimal,
	GetFirstDecimalDigitPosition: GetFirstDecimalDigitPosition,
	GetFirstDigitPosition: GetFirstDigitPosition,
	GetSingleDigitCharacterFromNumberWithCheck: GetSingleDigitCharacterFromNumberWithCheck,
	GetDecimalDigitCharacterFromNumberWithCheck: GetDecimalDigitCharacterFromNumberWithCheck,
	GetDigitCharacterTable: GetDigitCharacterTable,
	GetDecimalDigit: GetDecimalDigit,
	GetDecimalDigitWithFirstDigitPosition: GetDecimalDigitWithFirstDigitPosition,
	GetDigit: GetDigit,
	CreateNumberFromDecimalStringWithCheck: CreateNumberFromDecimalStringWithCheck,
	CreateNumberFromDecimalString: CreateNumberFromDecimalString,
	CreateNumberFromStringWithCheck: CreateNumberFromStringWithCheck,
	CreateNumberFromParts: CreateNumberFromParts,
	ExtractPartsFromNumberString: ExtractPartsFromNumberString,
	GetNumberFromNumberCharacterForBase: GetNumberFromNumberCharacterForBase,
	CharacterIsNumberCharacterInBase: CharacterIsNumberCharacterInBase,
	StringToNumberArray: StringToNumberArray,
	StringToNumberArrayWithCheck: StringToNumberArrayWithCheck,
	charToLowerCase: charToLowerCase,
	charToUpperCase: charToUpperCase,
	charIsUpperCase: charIsUpperCase,
	charIsLowerCase: charIsLowerCase,
	charIsLetter: charIsLetter,
	charIsNumber: charIsNumber,
	charIsWhiteSpace: charIsWhiteSpace,
	charIsSymbol: charIsSymbol,
	charCharacterIsBefore: charCharacterIsBefore,
	charDecimalDigitToCharacter: charDecimalDigitToCharacter,
	charCharacterToDecimalDigit: charCharacterToDecimalDigit,
	arraysStringToNumberArray: arraysStringToNumberArray,
	arraysNumberArrayToString: arraysNumberArrayToString,
	arraysNumberArraysEqual: arraysNumberArraysEqual,
	arraysBooleanArraysEqual: arraysBooleanArraysEqual,
	arraysStringsEqual: arraysStringsEqual,
	arraysFillNumberArray: arraysFillNumberArray,
	arraysFillString: arraysFillString,
	arraysFillBooleanArray: arraysFillBooleanArray,
	arraysFillNumberArrayRange: arraysFillNumberArrayRange,
	arraysFillBooleanArrayRange: arraysFillBooleanArrayRange,
	arraysFillStringRange: arraysFillStringRange,
	arraysCopyNumberArray: arraysCopyNumberArray,
	arraysCopyBooleanArray: arraysCopyBooleanArray,
	arraysCopyString: arraysCopyString,
	arraysCopyNumberArrayRange: arraysCopyNumberArrayRange,
	arraysCopyBooleanArrayRange: arraysCopyBooleanArrayRange,
	arraysCopyStringRange: arraysCopyStringRange,
	arraysIsLastElement: arraysIsLastElement,
	arraysCreateNumberArray: arraysCreateNumberArray,
	arraysCreateBooleanArray: arraysCreateBooleanArray,
	arraysCreateString: arraysCreateString,
	arraysSwapElementsOfNumberArray: arraysSwapElementsOfNumberArray,
	arraysSwapElementsOfStringArray: arraysSwapElementsOfStringArray,
	arraysReverseNumberArray: arraysReverseNumberArray,
	WriteStringToStingStream: WriteStringToStingStream,
	WriteCharacterToStingStream: WriteCharacterToStingStream,
	WriteBooleanToStingStream: WriteBooleanToStingStream,
	SubstringWithCheck: SubstringWithCheck,
	Substring: Substring,
	AppendString: AppendString,
	ConcatenateString: ConcatenateString,
	AppendCharacter: AppendCharacter,
	ConcatenateCharacter: ConcatenateCharacter,
	SplitByCharacter: SplitByCharacter,
	IndexOfCharacter: IndexOfCharacter,
	SubstringEqualsWithCheck: SubstringEqualsWithCheck,
	SubstringEquals: SubstringEquals,
	IndexOfString: IndexOfString,
	ContainsCharacter: ContainsCharacter,
	ContainsString: ContainsString,
	ToUpperCase: ToUpperCase,
	ToLowerCase: ToLowerCase,
	EqualsIgnoreCase: EqualsIgnoreCase,
	ReplaceString: ReplaceString,
	ReplaceCharacterToNew: ReplaceCharacterToNew,
	ReplaceCharacter: ReplaceCharacter,
	Trim: Trim,
	StartsWith: StartsWith,
	EndsWith: EndsWith,
	SplitByString: SplitByString,
	StringIsBefore: StringIsBefore,
	JoinStringsWithSeparator: JoinStringsWithSeparator,
	JoinStrings: JoinStrings,
	AddNumber: AddNumber,
	AddNumberRef: AddNumberRef,
	RemoveNumber: RemoveNumber,
	GetNumberRef: GetNumberRef,
	RemoveNumberRef: RemoveNumberRef,
	AddString: AddString,
	AddStringRef: AddStringRef,
	RemoveString: RemoveString,
	GetStringRef: GetStringRef,
	RemoveStringRef: RemoveStringRef,
	CreateDynamicArrayCharacters: CreateDynamicArrayCharacters,
	CreateDynamicArrayCharactersWithInitialCapacity: CreateDynamicArrayCharactersWithInitialCapacity,
	DynamicArrayAddCharacter: DynamicArrayAddCharacter,
	DynamicArrayCharactersIncreaseSize: DynamicArrayCharactersIncreaseSize,
	DynamicArrayCharactersDecreaseSizeNecessary: DynamicArrayCharactersDecreaseSizeNecessary,
	DynamicArrayCharactersDecreaseSize: DynamicArrayCharactersDecreaseSize,
	DynamicArrayCharactersIndex: DynamicArrayCharactersIndex,
	DynamicArrayCharactersLength: DynamicArrayCharactersLength,
	DynamicArrayInsertCharacter: DynamicArrayInsertCharacter,
	DynamicArrayCharacterSet: DynamicArrayCharacterSet,
	DynamicArrayRemoveCharacter: DynamicArrayRemoveCharacter,
	FreeDynamicArrayCharacters: FreeDynamicArrayCharacters,
	DynamicArrayCharactersToArray: DynamicArrayCharactersToArray,
	ArrayToDynamicArrayCharactersWithOptimalSize: ArrayToDynamicArrayCharactersWithOptimalSize,
	ArrayToDynamicArrayCharacters: ArrayToDynamicArrayCharacters,
	DynamicArrayCharactersEqual: DynamicArrayCharactersEqual,
	DynamicArrayCharactersToLinkedList: DynamicArrayCharactersToLinkedList,
	LinkedListToDynamicArrayCharacters: LinkedListToDynamicArrayCharacters,
	AddBoolean: AddBoolean,
	AddBooleanRef: AddBooleanRef,
	RemoveBoolean: RemoveBoolean,
	GetBooleanRef: GetBooleanRef,
	RemoveDecimalRef: RemoveDecimalRef,
	CreateLinkedListString: CreateLinkedListString,
	LinkedListAddString: LinkedListAddString,
	LinkedListStringsToArray: LinkedListStringsToArray,
	LinkedListStringsLength: LinkedListStringsLength,
	FreeLinkedListString: FreeLinkedListString,
	CreateLinkedListNumbers: CreateLinkedListNumbers,
	CreateLinkedListNumbersArray: CreateLinkedListNumbersArray,
	LinkedListAddNumber: LinkedListAddNumber,
	LinkedListNumbersLength: LinkedListNumbersLength,
	LinkedListNumbersIndex: LinkedListNumbersIndex,
	LinkedListInsertNumber: LinkedListInsertNumber,
	LinkedListSet: LinkedListSet,
	LinkedListRemoveNumber: LinkedListRemoveNumber,
	FreeLinkedListNumbers: FreeLinkedListNumbers,
	FreeLinkedListNumbersArray: FreeLinkedListNumbersArray,
	LinkedListNumbersToArray: LinkedListNumbersToArray,
	ArrayToLinkedListNumbers: ArrayToLinkedListNumbers,
	LinkedListNumbersEqual: LinkedListNumbersEqual,
	CreateLinkedListCharacter: CreateLinkedListCharacter,
	LinkedListAddCharacter: LinkedListAddCharacter,
	LinkedListCharactersToArray: LinkedListCharactersToArray,
	LinkedListCharactersLength: LinkedListCharactersLength,
	FreeLinkedListCharacter: FreeLinkedListCharacter,
	LinkedListCharactersAddString: LinkedListCharactersAddString,
	CreateDynamicArrayNumbers: CreateDynamicArrayNumbers,
	CreateDynamicArrayNumbersWithInitialCapacity: CreateDynamicArrayNumbersWithInitialCapacity,
	DynamicArrayAddNumber: DynamicArrayAddNumber,
	DynamicArrayNumbersIncreaseSize: DynamicArrayNumbersIncreaseSize,
	DynamicArrayNumbersDecreaseSizeNecessary: DynamicArrayNumbersDecreaseSizeNecessary,
	DynamicArrayNumbersDecreaseSize: DynamicArrayNumbersDecreaseSize,
	DynamicArrayNumbersIndex: DynamicArrayNumbersIndex,
	DynamicArrayNumbersLength: DynamicArrayNumbersLength,
	DynamicArrayInsertNumber: DynamicArrayInsertNumber,
	DynamicArrayNumberSet: DynamicArrayNumberSet,
	DynamicArrayRemoveNumber: DynamicArrayRemoveNumber,
	FreeDynamicArrayNumbers: FreeDynamicArrayNumbers,
	DynamicArrayNumbersToArray: DynamicArrayNumbersToArray,
	ArrayToDynamicArrayNumbersWithOptimalSize: ArrayToDynamicArrayNumbersWithOptimalSize,
	ArrayToDynamicArrayNumbers: ArrayToDynamicArrayNumbers,
	DynamicArrayNumbersEqual: DynamicArrayNumbersEqual,
	DynamicArrayNumbersToLinkedList: DynamicArrayNumbersToLinkedList,
	LinkedListToDynamicArrayNumbers: LinkedListToDynamicArrayNumbers,
	DynamicArrayNumbersIndexOf: DynamicArrayNumbersIndexOf,
	DynamicArrayNumbersIsInArray: DynamicArrayNumbersIsInArray,
	AddCharacter: AddCharacter,
	AddCharacterRef: AddCharacterRef,
	RemoveCharacter: RemoveCharacter,
	GetCharacterRef: GetCharacterRef,
	RemoveCharacterRef: RemoveCharacterRef,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	m18Negate: m18Negate,
	m18Positive: m18Positive,
	m18Factorial: m18Factorial,
	m18Round: m18Round,
	m18BankersRound: m18BankersRound,
	m18Ceil: m18Ceil,
	m18Floor: m18Floor,
	m18Truncate: m18Truncate,
	m18Absolute: m18Absolute,
	m18Logarithm: m18Logarithm,
	m18NaturalLogarithm: m18NaturalLogarithm,
	m18Sin: m18Sin,
	m18Cos: m18Cos,
	m18Tan: m18Tan,
	m18Asin: m18Asin,
	m18Acos: m18Acos,
	m18Atan: m18Atan,
	m18Atan2: m18Atan2,
	m18Squareroot: m18Squareroot,
	m18Exp: m18Exp,
	m18DivisibleBy: m18DivisibleBy,
	m18Combinations: m18Combinations,
	m18Permutations: m18Permutations,
	m18EpsilonCompare: m18EpsilonCompare,
	m18GreatestCommonDivisor: m18GreatestCommonDivisor,
	m18GCDWithSubtraction: m18GCDWithSubtraction,
	m18IsInteger: m18IsInteger,
	m18GreatestCommonDivisorWithCheck: m18GreatestCommonDivisorWithCheck,
	m18LeastCommonMultiple: m18LeastCommonMultiple,
	m18Sign: m18Sign,
	m18Max: m18Max,
	m18Min: m18Min,
	m18Power: m18Power,
	m18Gamma: m18Gamma,
	m18LogGamma: m18LogGamma,
	m18LanczosApproximation: m18LanczosApproximation,
	m18Beta: m18Beta,
	m18Sinh: m18Sinh,
	m18Cosh: m18Cosh,
	m18Tanh: m18Tanh,
	m18Cot: m18Cot,
	m18Sec: m18Sec,
	m18Csc: m18Csc,
	m18Coth: m18Coth,
	m18Sech: m18Sech,
	m18Csch: m18Csch,
	m18Error: m18Error,
	m18ErrorInverse: m18ErrorInverse,
	m18FallingFactorial: m18FallingFactorial,
	m18RisingFactorial: m18RisingFactorial,
	m18Hypergeometric: m18Hypergeometric,
	m18HypergeometricDirect: m18HypergeometricDirect,
	m18BernouilliNumber: m18BernouilliNumber,
	m18AkiyamaTanigawaAlgorithm: m18AkiyamaTanigawaAlgorithm,
	test: test
};